
#   Module  : ArXiv
#   Fichier : ArXiv.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/ArXiv.mod: $(DILIB)/Date/ArXiv.bin  \
                         $(DILIB)/Date/ArXiv.data
	$(TOUCH)

#----------------------------------------------------------------
# bin
#

$(DILIB)/Date/ArXiv.bin: $(DILIB)/bin/ArXivExplorDataShells \
                        $(DILIB)/bin/ArXivExplorSiteHtmlPhp        \
                        $(DILIB)/bin/ArXivExplorSiteShell   \
                          $(DILIB)/bin/ArXivToTei
	$(TOUCH)

$(DILIB)/bin/ArXivToTei:  $(DILIB_IMPORT)/ArXiv/ArXivToTei.c  \
                          $(DILIB)/Date/SxmlNode.lib         \
                          $(DILIB)/Date/Tei.lib
	$(CC)  $(DILIB_IMPORT)/ArXiv/ArXivToTei.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ArXivExplorDataShells: $(DILIB_IMPORT)/ArXiv/ArXivExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/ArXiv/ArXivExplorDataShells.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ArXivExplorSiteShell: $(DILIB_IMPORT)/ArXiv/ArXivExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/ArXiv/ArXivExplorSiteShell.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ArXivExplorSiteHtmlPhp: $(DILIB_IMPORT)/ArXiv/ArXivExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/ArXiv/ArXivExplorSiteHtmlPhp.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


#----------------------------------------------------------------
# data
#
$(DILIB)/Date/ArXiv.data: $(DILIB)/data/ArXiv/ExplorParam.en.tab  \
                          $(DILIB)/data/ArXiv/ExplorParam.fr.tab  \
                           $(DILIB)/data/icons/Arxiv.png       \
                          $(DILIB)/data/ArXiv/ExplorParam.data.tab
	$(TOUCH)

$(DILIB)/data/ArXiv/ExplorParam.data.tab: $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.data.wiki > $@

$(DILIB)/data/ArXiv/ExplorParam.en.tab: $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.en.wiki > $@

$(DILIB)/data/ArXiv/ExplorParam.fr.tab: $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/ArXiv/Data/ArXivExplorParam.fr.wiki > $@

$(DILIB)/data/icons/Arxiv.png:$(DILIB_IMPORT)/ArXiv/Data/Arxiv.png
	cp $(DILIB_IMPORT)/ArXiv/Data/Arxiv.png $@

#--------------------------- End ArXiv.mk ---------------------------
