/*   -*- coding: utf-8 -*-  */
/******************************************************************************
*
*               Module   : BnF
*               Fichier  : GallicaTxtToTei.c
*               Auteur   : J. DUCLOY
******************************************************************************/
#include "SxmlNode.h"
#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "TeiHandler.h"

SxmlNode *teiRoot;

int main(int argc, char **argv)
{
  SxmlNode *docInput;
  SxmlNode *docOutput;
  SxmlNode *htmlOutput;
  SxmlNode *textOutput;
  SxmlNode *inputHead;
  SxmlNode *inputBody;
  SxmlNode *outputBody;
  SxmlNode *outputHtmlBody;
  SxmlNode *inputNode;
  SxmlNode *outputDiv;
  int pageGallica;

  docInput=SxmlInputNextDocumentElement();
  if (SxmlNodeType(docInput)!=SXML_NODE_ELEMENT) 
    {
      SxmlNode *sibling;
      if ((sibling=SxmlNextSibling(docInput))) docInput=sibling;  
      else docInput=SxmlInputNextDocumentElement();
    }
  if (!docInput) exit (2);
  docOutput=SxmlElementCreate("record");
  SxmlAppendChild(docOutput, teiRoot=TeiHandlerNew());
  SxmlAppendChild(docOutput, htmlOutput=SxmlElementCreate("html"));
  inputHead=SxmlGetFirstChildByTagName(docInput,"head");
  inputBody=SxmlGetFirstChildByTagName(docInput,"body");
  SxmlAppendChild(htmlOutput, SxmlClone(inputHead));
  SxmlAppendChild(htmlOutput, outputHtmlBody=SxmlElementCreate("body"));
  SxmlAppendChild(teiRoot, textOutput=SxmlElementCreate("text"));
  SxmlAppendChild(textOutput, outputBody=SxmlElementCreate("body"));

  while ((inputNode=SxmlNextNode(inputBody)))
    {
      if (SxmlNodeHasName(inputNode, "hr"))break;
      SxmlAppendChild(outputHtmlBody, SxmlClone(inputNode));
    }

  SxmlAppendChild(outputBody, outputDiv=SxmlElementCreate("div"));

  pageGallica=1;

  while ((inputNode=SxmlNextSibling(inputNode)))
    {
      SxmlNode *outputParNode;
      if (SxmlNodeHasName(inputNode, "hr"))
	{
	  pageGallica++;
	  continue;
	}
      SxmlAppendChild(outputDiv, outputParNode=SxmlClone(inputNode));
      SxmlSetIntAttribute (outputParNode, "pageGallica", pageGallica);
    }

  SxmlPrint (docOutput);
  putchar('\n');
  exit(EXIT_SUCCESS);
}
