
#   Module  : Ccsd
#   Fichier : Ccsd.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Ccsd.mod: $(DILIB)/Date/Ccsd.bin \
                                $(DILIB)/Date/Ccsd.data
	$(TOUCH)

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Ccsd.data:$(DILIB)/data/Ccsd/ExplorParam.data.tab  \
                               $(DILIB)/data/Ccsd/ExplorParam.en.tab  \
                               $(DILIB)/data/Ccsd/ExplorParam.fr.tab  \
                               $(DILIB)/data/icons/LogoHal.gif
	$(TOUCH)

$(DILIB)/data/Ccsd/ExplorParam.data.tab: $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.data.wiki > $@

$(DILIB)/data/Ccsd/ExplorParam.en.tab: $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.en.wiki > $@

$(DILIB)/data/Ccsd/ExplorParam.fr.tab: $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Ccsd/Data/CcsdExplorParam.fr.wiki > $@

$(DILIB)/data/icons/LogoHal.gif:$(DILIB_IMPORT)/Ccsd/Data/LogoHal.gif
	cp $(DILIB_IMPORT)/Ccsd/Data/LogoHal.gif $@

#----------------------------------------------------------------
# bin
#

$(DILIB)/Date/Ccsd.bin:$(DILIB)/bin/CcsdExplorDataShells \
                        $(DILIB)/bin/CcsdHal2CorpusStep1  \
                        $(DILIB)/bin/CcsdHal2CorpusStep2  \
                        $(DILIB)/bin/CcsdHalTei2Corpus  \
                        $(DILIB)/bin/CcsdExplorSiteHtmlPhp        \
                        $(DILIB)/bin/CcsdExplorSiteShell   \
                        $(DILIB)/bin/CcsdHalAffiliationSetPays
	$(TOUCH)

$(DILIB)/bin/CcsdExplorDataShells: $(DILIB_IMPORT)/Ccsd/CcsdExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdExplorDataShells.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/CcsdHal2CorpusStep1: $(DILIB_IMPORT)/Ccsd/CcsdHal2CorpusStep1.c \
                            $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdHal2CorpusStep1.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/CcsdHalTei2Corpus: $(DILIB_IMPORT)/Ccsd/CcsdHalTei2Corpus.c \
                            $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdHalTei2Corpus.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/CcsdHal2CorpusStep2: $(DILIB_IMPORT)/Ccsd/CcsdHal2CorpusStep2.c \
                            $(DILIB)/Date/SxPath.lib            \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdHal2CorpusStep2.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/CcsdHalAffiliationSetPays: $(DILIB_IMPORT)/Ccsd/CcsdHalAffiliationSetPays.c \
                            $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdHalAffiliationSetPays.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/CcsdExplorSiteShell: $(DILIB_IMPORT)/Ccsd/CcsdExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdExplorSiteShell.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/CcsdExplorSiteHtmlPhp: $(DILIB_IMPORT)/Ccsd/CcsdExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Ccsd/CcsdExplorSiteHtmlPhp.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#--------------------------- End Ccsd.mk ---------------------------
