#
#   Module  : DamRecord
#   Fichier : DamRecord.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/DamRecord.mod:  $(DILIB)/Date/DamRecord.include \
                               $(DILIB)/Date/DamRecord.man         \
                               $(DILIB)/Date/DamRecord.lib
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/DamRecord.include: $(DILIB)/include/DamRecord.h  \
                                        $(DILIB)/include/DamFile.h
	$(TOUCH)

$(DILIB)/include/DamRecord.h: $(DILIB_IMPORT)/DamRecord/DamRecord.h  \
                              $(DILIB)/include/SgmlNode.h
	cp $(DILIB_IMPORT)/DamRecord/DamRecord.h $@

$(DILIB)/include/DamFile.h: $(DILIB_IMPORT)/DamRecord/DamFile.h  \
                              $(DILIB)/include/DamRecord.h
	cp $(DILIB_IMPORT)/DamRecord/DamFile.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/DamRecord.lib:$(DILIB)/Date/DamFile.o \
                                   $(DILIB)/Date/DamFileContent.o \
                                   $(DILIB)/Date/DamRecord.o \
                                   $(DILIB)/Date/RegExp.o \
                                   $(DILIB)/Date/DamRecordToSgml.o 
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/DamFile.o:$(DILIB_IMPORT)/DamRecord/DamFile.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/DamRecord/DamFile.c   -I$(DILIB)/include            \
	      -c -o DamFile.o
	ar ruv  $(DILIB)/lib/libDilib.a   DamFile.o
	$(TOUCH)

$(DILIB)/Date/DamFileContent.o:$(DILIB_IMPORT)/DamRecord/DamFileContent.c \
                         $(DILIB)/include/SgmlNodePrivate.h
	$(CC) $(DILIB_IMPORT)/DamRecord/DamFileContent.c   -I$(DILIB)/include            \
	      -c -o DamFileContent.o
	ar ruv  $(DILIB)/lib/libDilib.a   DamFileContent.o
	$(TOUCH)

$(DILIB)/Date/DamRecord.o:$(DILIB_IMPORT)/DamRecord/DamRecord.c \
                         $(DILIB)/include/RegExp.h
	$(CC) $(DILIB_IMPORT)/DamRecord/DamRecord.c   -I$(DILIB)/include            \
	      -c -o DamRecord.o
	ar ruv  $(DILIB)/lib/libDilib.a   DamRecord.o
	$(TOUCH)

$(DILIB)/Date/DamRecordToSgml.o:$(DILIB_IMPORT)/DamRecord/DamRecordToSgml.c \
                         $(DILIB)/include/DamRecord.h
	$(CC) $(DILIB_IMPORT)/DamRecord/DamRecordToSgml.c   -I$(DILIB)/include            \
	      -c -o DamRecordToSgml.o
	ar ruv  $(DILIB)/lib/libDilib.a   DamRecordToSgml.o
	$(TOUCH)

#--------------------------------------------------------------------
#    La Documentation par man d'Unix

$(DILIB)/Date/DamRecord.man:
	$(TOUCH)


