

%START SAUT
%START TABLE
%START ROW
%START ID_LIST
%START ID_WIKI
%START ID
%START VALUE
%START WIKI
%START LIST
%START TAGS
%START LINKS

%%
<SAUT>.                      ;
<SAUT>\n                     ;
<SAUT>"\{|"                  BEGIN TABLE;
<TABLE>"|-"\n"!"             ;
<TABLE>.                     ;
<TABLE>\n                    ;
<TABLE>"|-"                    {BEGIN ROW;}
<ROW>[ ]*\n"|List/"            {printf("%s", yytext+2); BEGIN ID_LIST;}
<ROW>[ ]*\n"|IndexType/"       {printf("%s", yytext+2); BEGIN ID_LIST;}
<ROW>[ ]*\n"|Wiki/"            {printf("%s", yytext+2); BEGIN ID_WIKI;}
<ROW>[ ]*\n"|introduction\/"    {printf("%s", yytext+2); BEGIN ID_WIKI;}
<ROW>[ ]*\n"|"                 {BEGIN ID;}
<ID>[ ]*\n"|"                  {putchar ('\t'); BEGIN VALUE;}
<ID>.                          ECHO;
<ID_LIST>[ ]*\n"|"             {printf ("\t<list><i>"); BEGIN LIST;}
<ID_LIST>.                     ECHO;
<ID_WIKI>[ ]*\n"|"             {printf ("\t<wicri>"); BEGIN WIKI;}
<ID_WIKI>.                     ECHO;
<VALUE>[ ]*\n"|-"              {putchar ('\n'); BEGIN ROW;}
<VALUE>.                       ECHO;
<WIKI>\n                       printf ("&#x0a;");
<WIKI>[ ]*\n"|-"               {printf ("</wicri>\n"); BEGIN ROW;}
<WIKI>"<"                      {printf("<tag>"); BEGIN TAGS;}
<WIKI>[^\{\[\}<\n]+            {printf("<text>%s</text>",yytext);}
<WIKI>"\[\["                   {printf("<link>"); BEGIN LINKS;}
<TAGS>[^>]                     ECHO;
<TAGS>">"                      {printf("</tag>"); BEGIN WIKI;}
<LIST>[ ]*\n"|-"               {printf ("</i></list>\n"); BEGIN ROW;}
<LIST>[ ]*";"[ ]*              printf("</i><i>");
<LIST>.                        ECHO;
<LINKS>.                        ECHO;
<LINKS>"\]\]"                   {printf("</link>");BEGIN WIKI;}
<ROW>[ ]*\n"|\}"                 BEGIN SAUT;
%%
main()
{
  BEGIN SAUT;
  yylex();
}
