%{
#include "Buffer.h"
  int startZ3;
  int retInclude;
  Buffer *bufItem;
%}

%START OUT
%START TABLE
%START ROW
%START  Z1
%START  Z2
%START  Z3
%START ZLIST
%START LIST
%START ZPHP
%START PHP
%START ZWIKI
%START ZHTML
%START WIKI
%START TAGS
%START LINKS
%START HTML
%START INC
%START INC_KEY

%%
<OUT>.                        ;
<OUT>\n                       ;
<OUT>"\{|"                    BEGIN TABLE;
<TABLE>"|-"\n"!"              ;
<TABLE>.                      ;
<TABLE>\n                     ;
<TABLE>"|-"                   {BEGIN ROW;}
<ROW>[ ]*\n"|list#"           {BEGIN Z1; BufferReset(bufItem); startZ3=ZLIST; }
<ROW>[ ]*\n"|php#"            {BEGIN Z1; BufferReset(bufItem); startZ3=ZPHP; }
<ROW>[ ]*\n"|wiki#"           {BEGIN Z1; BufferReset(bufItem); startZ3=ZWIKI; }
<ROW>[ ]*\n"|html#"           {BEGIN Z1; BufferReset(bufItem); startZ3=ZHTML; }
<ROW>[ ]*\n"|"                {BEGIN Z1; BufferReset(bufItem); startZ3=Z3;}
<ROW>[ ]*\n"|\}"              BEGIN OUT;
<Z1>[ ]*\n"|"                 {BEGIN Z2;}
<Z1>.                         {BufferStrcat(bufItem, yytext);}
<Z2>[ ]*\n"|"                 {BEGIN startZ3; printf ("/%s\t", BufferString(bufItem));}
<Z2>.                         ECHO;
<Z3>[ ]*\n"|"[\-]*            {putchar ('\n'); BEGIN ROW;}
<Z3>.                         ECHO;
<ZLIST>[ ]                    ;
<ZLIST>.                      {printf("<list><i>%s", yytext); BEGIN LIST;}
<LIST>[ ]*\n"|"[\-]*          {printf ("</i></list>\n"); BEGIN ROW;}
<LIST>[ ]*";"[ ]*              printf("</i><i>");
<LIST>.                       ECHO;
<ZWIKI>[ ]                    ;
<ZWIKI>"<"                    {printf("<wiki><tag>"); BEGIN TAGS;}
<ZWIKI>"\[\["                 {printf("<wiki><link>"); BEGIN LINKS;}
<ZWIKI>[^\{\[\}<\n]+          {printf("<wiki><text>%s</text>",yytext); BEGIN WIKI;}
<ZWIKI>.                      {printf("<wiki>%s", yytext); BEGIN WIKI;}
<WIKI>\n                      printf ("&#x0a;");
<WIKI>[ ]*\n"|"[\-]*          {printf ("</wiki>\n"); BEGIN ROW;}
<WIKI>"<"                     {printf("<tag>"); BEGIN TAGS;}
<WIKI>[^\{\[\}<\n]+           {printf("<text>%s</text>",yytext);}
<WIKI>"\[\["                  {printf("<link>"); BEGIN LINKS;}
<WIKI>"\{\{Explor"[ ]+"include"[ ]*"\|"  {printf("<include>"); BEGIN INC; retInclude=WIKI;}
<LINKS>"\{\{Explor"[ ]+"include"[ ]*"\|"  {printf("<include>"); BEGIN INC; retInclude=LINKS;}
<WIKI>.                      ;
<INC>.                        ;
<INC>"key"[ ]*=[ ]*            {printf ("<key>");BEGIN INC_KEY;}
<INC>"\}\}"                     {printf("</include>"); BEGIN retInclude;}
<INC_KEY>[^\|\]]              ECHO;
<INC_KEY>[^\|\]]/[\|\}]       {ECHO;printf ("</key>"); BEGIN INC;}        
<TAGS>[^>]                    ECHO;
<TAGS>">"                     {printf("</tag>"); BEGIN WIKI;}
<LINKS>.                      ECHO;
<LINKS>"\]\]"                 {printf("</link>");BEGIN WIKI;}
<ZPHP>[ ]*"<source"[^>]+">"    {printf("<php><l>");BEGIN PHP;}
<PHP>[ \n]*"</source>"[ ]*\n"|"[\-]* {printf ("</l></php>\n"); BEGIN ROW;}
<PHP>[ ]*\n                   printf("</l><l>");
<PHP>"&"                      printf("&amp;");
<PHP>[\"]                     printf("&dquot;");
<PHP>[\']                     printf("&quot;");
<PHP>"<"                      printf("&lt;");
<PHP>">"                      printf("&gt;");
<PHP>.                        ECHO;
<ZHTML>[ ]*"<source"[^>]+">"    {printf("<html>");BEGIN HTML;}
<HTML>[ \n]*"</source>"[ ]*\n"|"[\-]* {printf ("</html>\n"); BEGIN ROW;}
<HTML>.                        ECHO;
<HTML>\n                       putchar(' ');
%%
int main()
{
  BEGIN OUT;
  bufItem=NewBuffer();
  yylex();
  return 0;
}
