#
#   Module  : Index
#   Fichier : Index.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/Index.mod:    $(DILIB)/Date/Index.bin \
                                  $(DILIB)/Date/Index.include \
                                  $(DILIB)/Date/Index.man     \
                                  $(DILIB)/Date/Index.php     \
                                  $(DILIB)/Date/Index.lib
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/Index.include: $(DILIB)/include/IndexFast.h \
                        $(DILIB)/include/Index.h                 \
                        $(DILIB)/include/Histo.h
	$(TOUCH)

$(DILIB)/include/IndexFast.h: $(DILIB_IMPORT)/Index/IndexFast.h
	cp $(DILIB_IMPORT)/Index/IndexFast.h $@

$(DILIB)/include/Index.h: $(DILIB_IMPORT)/Index/Index.h \
                     $(DILIB)/Date/SgmlNode.include \
                     $(DILIB)/Date/DamHfd.include
	cp $(DILIB_IMPORT)/Index/Index.h $@

$(DILIB)/include/Histo.h: $(DILIB_IMPORT)/Index/Histo.h \
                     $(DILIB)/Date/SgmlNode.include 
	cp $(DILIB_IMPORT)/Index/Histo.h $@

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Index.bin:$(DILIB)/bin/IndexBuildRec \
                        $(DILIB)/bin/IndexBuildHid \
                        $(DILIB)/bin/IndexSelect \
                        $(DILIB)/bin/IndexBuildUsual \
                        $(DILIB)/bin/AssocBuildUsual \
                        $(DILIB)/bin/AssocFastWithIndex \
                        $(DILIB)/bin/AssocFastFromIndex \
                        $(DILIB)/bin/IndexFastBuildRec \
                        $(DILIB)/bin/IndexClusterFromAssoc \
                        $(DILIB)/bin/IndexClusterName \
                        $(DILIB)/bin/IndexHistoBuilder \
                        $(DILIB)/bin/IndexAssocCosinus \
                        $(DILIB)/bin/IndexClusterSetFromHisto  \
                        $(DILIB)/bin/HistoBuildRec 
	$(TOUCH)

$(DILIB)/bin/IndexBuildRec: $(DILIB_IMPORT)/Index/IndexBuildRec.c  \
                        $(DILIB)/Date/SgmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexBuildRec.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexBuildUsual:$(DILIB_IMPORT)/Index/IndexBuildUsual  \
                         $(DILIB)/bin/IndexBuildRec \
                        $(DILIB)/bin/IndexBuildHid \
                        $(DILIB)/bin/IndexFastBuildRec
	$(MAKE_SHELL) $(DILIB_IMPORT)/Index/IndexBuildUsual $@

$(DILIB)/bin/AssocBuildUsual:$(DILIB_IMPORT)/Index/AssocBuildUsual  \
                         $(DILIB)/bin/IndexBuildRec \
                        $(DILIB)/bin/IndexBuildHid \
                        $(DILIB)/bin/AssocFastWithIndex
	$(MAKE_SHELL) $(DILIB_IMPORT)/Index/AssocBuildUsual $@


$(DILIB)/bin/IndexBuildHid: $(DILIB_IMPORT)/Index/IndexBuildHid.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexBuildHid.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexHistoBuilder: $(DILIB_IMPORT)/Index/IndexHistoBuilder.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexHistoBuilder.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/IndexSelect: $(DILIB_IMPORT)/Index/IndexSelect.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexSelect.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/AssocFastWithIndex: $(DILIB_IMPORT)/Index/AssocFastWithIndex.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/AssocFastWithIndex.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/AssocFastFromIndex: $(DILIB_IMPORT)/Index/AssocFastFromIndex.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/AssocFastFromIndex.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexClusterFromAssoc: $(DILIB_IMPORT)/Index/IndexClusterFromAssoc.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexClusterFromAssoc.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexClusterName: $(DILIB_IMPORT)/Index/IndexClusterName.c  \
                       $(DILIB)/Date/Index.lib \
                        $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexClusterName.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexAssocCosinus: $(DILIB_IMPORT)/Index/IndexAssocCosinus.c  \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexAssocCosinus.c   -I$(DILIB)/include \
	                    -lm     $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexFastBuildRec: $(DILIB_IMPORT)/Index/IndexFastBuildRec.c  \
                        $(DILIB)/Date/SgmlNode.lib \
                       $(DILIB)/Date/Index.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexFastBuildRec.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IndexClusterSetFromHisto: $(DILIB_IMPORT)/Index/IndexClusterSetFromHisto.c  \
                        $(DILIB)/Date/SgmlNode.lib \
                       $(DILIB)/Date/Index.lib
	$(CC)  $(DILIB_IMPORT)/Index/IndexClusterSetFromHisto.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/HistoBuildRec: $(DILIB_IMPORT)/Index/HistoBuildRec.c  \
                        $(DILIB)/Date/SgmlNode.lib \
                       $(DILIB)/Date/Index.lib
	$(CC)  $(DILIB_IMPORT)/Index/HistoBuildRec.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Index.php: $(DILIB)/php/Index/Index.php
	$(TOUCH)

$(DILIB)/php/Index/Index.php: $(DILIB_IMPORT)/Index/Index.php
	cp $(DILIB_IMPORT)/Index/Index.php $@



#--------------------------------------------------------------------
# la librairie Dilib
#
 $(DILIB)/Date/Index.lib: $(DILIB)/Date/IndexFast.o \
                           $(DILIB)/Date/IndexRead.o  \
                           $(DILIB)/Date/Histo.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/IndexFast.o:$(DILIB_IMPORT)/Index/IndexFast.c \
                            $(DILIB)/Date/Index.include \
                            $(DILIB)/Date/DamHfd.lib
	$(CC) $(DILIB_IMPORT)/Index/IndexFast.c  -I$(DILIB)/include      \
                     -c -o IndexFast.o
	ar ruv $(DILIB)/lib/libDilib.a   IndexFast.o
	$(TOUCH)

$(DILIB)/Date/IndexRead.o:$(DILIB_IMPORT)/Index/IndexRead.c \
                            $(DILIB)/Date/Index.include \
                            $(DILIB)/Date/DamHfd.lib
	$(CC) $(DILIB_IMPORT)/Index/IndexRead.c  -I$(DILIB)/include      \
                     -c -o IndexRead.o
	ar ruv $(DILIB)/lib/libDilib.a   IndexRead.o
	$(TOUCH)

$(DILIB)/Date/Histo.o:$(DILIB_IMPORT)/Index/Histo.c \
                            $(DILIB)/Date/Index.include \
                            $(DILIB)/Date/SgmlNode.lib
	$(CC) $(DILIB_IMPORT)/Index/Histo.c  -I$(DILIB)/include      \
                     -c -o Histo.o
	ar ruv $(DILIB)/lib/libDilib.a   Histo.o
	$(TOUCH)

#--------------------------------------------------------------------
#    La Documentation par man d'Unix
#

$(DILIB)/Date/Index.man:$(DILIB)/man/man1/IndexBuild.1 \
                         $(DILIB)/man/man1/IndexSelect.1
	$(TOUCH)

$(DILIB)/man/man1/IndexBuild.1:$(DILIB_IMPORT)/Index/IndexBuild.1.man
	$(MAKEMAN) $(DILIB_IMPORT)/Index/IndexBuild.1.man Index > $@

$(DILIB)/man/man1/IndexSelect.1:$(DILIB_IMPORT)/Index/IndexSelect.1.man
	$(MAKEMAN) $(DILIB_IMPORT)/Index/IndexSelect.1.man Index > $@

#--------------------------- end Index.mk ---------------
