.TH IndexBuild 1 "21 November 1994"
.SH NAME
IndexBuild : IndexBuildUsual IndexBuildRec, IndexBuildHid, IndexBuildFromFile \- building index records and inverted files.
.SH SYNOPSIS
.SS User Level
.PP
.B IndexBuildUsual
.B \-h 
.I hfdRadical
.B \-k
.I keywordPath
.B \-i
.I indexCode
.B \-s
.I numberRecordToSort
[
.B \-w
.I workSpace
.PP
.B IndexBuildFromFile
.B \-b
.I base
.B \-i
.I indexCode
[
.B \-w
.I workSpace
]
[
.B \-f
.I inputFile
]
.SS Development Level 
.PP
.B IndexBuildRec
[
.B \-e
.I elementTag
] [
.B \-f
.I freqTag
] [
.B \-k
.I keyTag
] [
.B \-l
.I listTag
] [
.B \-r
.I recordTag
] [
.B \-s
.I maxTermToSort
] [
.B -\F
freqFormat
] [
.B \-A
] [
.B \-S
]
.PP
.B IndexBuildHid
.B \-h
.I hfdName
[
.B \-e
.I entryTag
] [
.B \-n
] 
.SH DESCRIPTION
.SS User Level
.PP
.B IndexBuildUsual
builds an inverted file from primary hfd file in usual cases.
(this primary hfd file must be suffixed by ".bib.hfd").
Rquired options are the following:
.TP 10
.B \-b 
name (without suffix) of the DILIB base which must contain a 
.IR base .bib.hfd
HFD file.
.TP
.B \-h 
name (without suffix ."bib.hfd") of hfd
.IR hfdRadical. - deprecated (see 
.B \-b option
).
.TP
.B \-k
introduces
.I keywordPath
as Sgml Path containing descriptors to be indexed.
.TP 
.B \-i 
introduces 
.I indexCode
as field name and suffix of inverted files.
.TP 
.B \-s
introduces the number of record to store in ".sort" file.
.B \-w
introduces workspace for sorting.
.PP
.B IndexBuildFromFile
creates a new index form a file containind pairs (key <tab> record number).
.SS User Level - Example
.PP
creating index myBase.iaut.hfd from repeatable field author of primary hfd file myBase.bib.hfd:
.PP
   IndexBuildUsual -b myBase -k doc/author# -i aut
.PP
.SS Development Level 
.PP
.B IndexBuildRec
builds index records from 
stream containing tupples whose first element is the entry of index and 
whose last one is a value (generaly key of primary record).
.PP
According to Dam rules, separator of values of tupples is tabulation mark.
.PP 
Index records are SGML marked according to the following skeleton of DTD:
.ta +1i
.PP
	<!ELEMENT
.I recordTag
\- \- (
.IR keyTag ,
\.\.\.
.IR freqTag ,
.IR listTag >
.PP
Depending on \-s option listTag may be a list of SGML elements according to DTD rule:
.PP
	<!ELEMENT 
.I listTag
\- \- (
.IR elementTag +)>
.SH OPTIONS
.TP 15
.RI \- e elementTag
is the tag of element of list of inverteg list (implicit value is "e").
If the 
.I elementTag
value is equal to exclamation mark (!), input elements are treated
as Sgml elements and are stored into the list without this element tag.
.TP 
.RI \-f freqTag
is the tag of frequency element (implicit value is "f").
.TP 
.RI \-k keyTag
is the tag associated to entry of inverted file (implicit value is "k").
.TP
.RI \-l listTag
is the tag of inverted list (implicit value is "l").
.TP
.RI \-s separator
is defined this option generates for inverted list just a string of
elements separated by
.IR separator .
.TP
.I \-F freqFormat
is the format specification (see 
.BR printf (3))
used to produce frequency element (implicit value is "%d").
.TP
.R \-A
(assoc mode) builds index record using two first fields of input record.
.TP
.R \-S 
(short mode) only prints members of assoc and frequency.
.PP
.B IndexBuildHid
builds HID (Hfd Index Directory) of a given Hfd file
.I hfdName
whose entry are marked (in inverted file) by:
.IR entryTag .
This command modifies ".hcs" file, adding an index description.
Option 
.B \-n
stands for no execution mode (prints HID on stdin and does not modify ".hcs" file.
.SH EXAMPLES
.PP
From input, sorted by alphabetical order:
.PP
.ta +1i +1.5i
.nf
	DOCUMENT	01AF
	DTD	0020
	DTD	0F10
.fi
.PP
.B IndexBuildRec
gives:
.PP
.TA +1
.nf
	<idx><k>DOCUMENT</k><f>1</f><l><e>01AF</e></l></idx>
	<idx><k>DTD</k><f>2</f><l><e>0020</e><e>0F10</e></l></idx>
.fi
.PP
With input:
.nf
	COMPILATION	024867
	COMPUTER	002345
	COMPUTER	013456
.fi
Compatible INIST Ilib index may be obtained with:
.PP
	IndexBuildRec  -r index -k e -s,
.PP
and will produce:
.nf
	<index><e>COMPILATION</e><f>1</f><l>024867</l></index>
	<index><e>COMPUTER</e><f>2</f><l>002345,013456</l></index>
.fi
.PP
From document:
.PP
.ta +1i +1.5i +3i
.nf
	ame	<E>&acirc;me</E>	034839
	ame	<E>&acirc;me</E>	082003
	croise	<E>crois&eacute;</E>	082134
	demon	<E>d&eacute;mon</E>	003810
	france	<E>FRANCE</E>	083240
	france	<E>FRANCE</E>	124816
.fi
.PP
The same command will give:
.PP
.nf
	<index><e>croise</e><E>crois&eacute;</E><f>1</f><l>082134</l></index>
	<index><e>demon</e><E>d&eacute;mon</E><f>1</f><l>003810</l></index>
	<index><e>france</e><E>FRANCE</E><f>2</f><l>083240,124816</l></index>
.SH WARNING
When input records gets same key with different embedded informations, only
last ones are kept. Exemple input file:
.PP
.nf
 	france	<E>France</E>	083240
	france	<E>FRANCE</E>	124816
.fi
.PP
will give:
.PP
	<index><e>france</e><E>FRANCE</E><f>2</f><l>083240,124816</l></index>
.PP
.SH AUTHORS
.PP
Origin: first implementation in Ilib (INIST) J. DUCLOY, P. CHARPENTIER, D. BESAGNI).
.PP
Dilib version: LORIA - J. DUCLOY
.PP
Recent changes: INRS - L. MIDON



