/**********************************************************************
*
*  projet   : DilibPro
*  module   : Index
*  commande : IndexBuildRec
*  fichier  : IndexBuildRec.c
*  Auteur   : Jacques DUCLOY
*  Date     : Octobre 93
*  Modifications : Janvier 94
*  $Id: IndexBuildRec.c,v 1.2 2003/03/17 16:30:00 parmentf Exp $
*
***********************************************************************/
#include "ctype.h"
#include "DamFile.h"
#include "SgmlInput.h"

void perror();
#include <string.h>

static SgmlNode *recordKey=NULL;
static SgmlNode *newKey;
static SgmlNode *assocKey;
static SgmlNode *outputList;
static SgmlNode *oldRecord=NULL;
static int f;
static int firstElement;

static char *elementTag;
static char *freqTag;
static char *keyTag;
static char *listTag;
static char *recordTag;
static char *extensionTag;
static char *tiTag;
static char *tjTag;

static char *freqFormat;

static char *separator;

               /*             flags associes aux options */

static int    flagList;
static int    flagShort;
static int    flagAssoc;

              /*             flags associs aux librations */

static int    flagAssocKeyToFree;

void initList()
{
  f=0;
  firstElement=1;

  recordKey=SgmlCopy(newKey);

  if(flagAssoc)
    {
      if (flagAssocKeyToFree) SgmlFree(assocKey);
      assocKey=SgmlCopy(SgmlNext(newKey));
      flagAssocKeyToFree=1;
    }

  if(flagList)
    {
      if(separator)
	{
	  outputList=SgmlCreateLeaf(listTag,"");
	}
      else
	{
	  outputList=SgmlCreateMark(listTag);
	}
    }
}

void purgeList()
{
  SgmlNode *outputRecord;
  SgmlNode *outputKey;
  SgmlNode *outputFreq;
  SgmlNode *inputElem;
  SgmlNode *extElem;
  SgmlNode *outputAssoc;
  char     strFreq[10];

  if(flagShort)
    {
      SgmlPrint(recordKey);
      putchar('\t');
      if(flagAssoc)
	{
	  SgmlPrint(assocKey);
	  putchar('\t');
	}
      printf(freqFormat,f);
      putchar('\n');
      SgmlFree(recordKey);
    }
  else
    {
      outputRecord=SgmlCreateMark(recordTag);

      if(flagAssoc)outputKey=SgmlCreateMark(tiTag);
      else outputKey=SgmlCreateMark(keyTag);
      SgmlAddSon(outputKey,recordKey);
      SgmlAddSon(outputRecord,outputKey);

      if(flagAssoc)
	{
	  outputAssoc=SgmlCreateMark(tjTag);
	  SgmlAddSon(outputAssoc,assocKey);
	  flagAssocKeyToFree=0;
	  SgmlAddSon(outputRecord,outputAssoc);
	}

      if(flagAssoc)inputElem=SgmlGetSonNumber(oldRecord,3);
      else inputElem=SgmlGetSonNumber(oldRecord,2);

      if (inputElem)
	{
	  do
	    {
	      if(SgmlNext(inputElem)) 
		{
		  if(extensionTag)
		    {
		      extElem=SgmlCreateMark(extensionTag);
		      SgmlAddSon(outputRecord, extElem);
		      SgmlAddSon(extElem,SgmlCopy(inputElem));
		    }
		  else SgmlAddSon(outputRecord,SgmlCopy(inputElem));
		}
	    }
	  while ((inputElem=SgmlNext(inputElem)));
	}
      sprintf(strFreq,freqFormat,f);
      outputFreq=SgmlCreateLeaf(freqTag, strFreq);
      SgmlAddSon(outputRecord,outputFreq);
      if(flagList)SgmlAddSon(outputRecord,outputList);
      SgmlPrint(outputRecord);
      putchar('\n');
      SgmlFree(outputRecord);
    }
}

void elemList()
{
  SgmlNode *elem;
  if(flagList)
    {
      if(separator)
	{
	  if(firstElement)
	    {
	      firstElement=0;
	    }
	  else
	    {
	      SgmlLeafStrcat(outputList,separator);
	    }
	  SgmlLeafStrcat
	    (outputList, SgmlGetFirstData(SgmlLast(SgmlInputRecord)));
	}
      else
	{
	  if ((elementTag[0]!='!'))
	    {
	      elem=SgmlCreateMark(elementTag);
	      SgmlAddSon(elem,SgmlCopy(SgmlLast(SgmlInputRecord)));
	      SgmlAddSon(outputList,elem);
	    }
	  else
	    SgmlAddSon(outputList,SgmlCopy(SgmlLast(SgmlInputRecord)));
	}
    }
  f++;
  if(oldRecord)SgmlFree(oldRecord);
  oldRecord=SgmlCopy(SgmlInputRecord);
}

void usage()
{
  perror ("usage: IndexBuildRec [-L] [-e elementTag] [-f freqTag] [-l listTag] [-r recordTag] [-k keyTag] [-E extensionTag]  \n");
  exit(1);
}


    int getopt();
    extern char *optarg;

int main(argc,argv)
     int argc;
     char **argv;
{
  int cod_arg;

  elementTag="e";
  freqTag="f";
  keyTag="k";
  listTag="l";
  recordTag="idx";
  tiTag="ti";
  tjTag="tj";

  flagAssoc=0;
  flagList=1;
  flagShort=0;

  flagAssocKeyToFree=0;

  extensionTag=NULL;

  freqFormat="%d";

  separator=NULL;

  while (((cod_arg = getopt(argc,argv,"e:f:i:j:k:l:r:s:x:AF:LS"))!=EOF))
    {
      switch(cod_arg) 
	{
	case 'e':
	  elementTag=optarg;
	  break;
	case 'f':
	  freqTag=optarg;
	  break;
	case 'i':
	  tiTag=optarg;
	  break;
	case 'j':
	  tjTag=optarg;
	  break;
	case 'k':
	  keyTag=optarg;
	  break;
	case 'l':
	  listTag=optarg;
	  break;
	case 'r':
	  recordTag=optarg;
	  break;
	case 's':
	  separator=optarg;
	  break;
	case 'x':
	  extensionTag=optarg;
	  break;
	case 'A':
	  flagAssoc=1;
	  break;
	case 'F':
	  freqFormat=optarg;
	  break;
	case 'L':
	  flagList=0;
	  break;
	case 'S':
	  flagShort=1;
	  flagList=0;
	  break;
	default: 
	  usage();
	}
    }

  while(SgmlInputNextRecord())
    {
      newKey=SgmlFirst(SgmlInputRecord);
      if(!recordKey) initList();
      else 
	{
	  if(!SgmlEqualSubTree(recordKey,newKey))
	    {
	      purgeList();
	      initList();
	    }
	  else
	    {
	      if(flagAssoc)
		{
		  if(!SgmlEqualSubTree(assocKey,SgmlNext(newKey)))
		    {
		      purgeList();
		      initList();
		    }
		}
	    }
	}
      elemList();
    }
  purgeList();
  return 0;
}
