/*   -*- coding: utf-8 -*-  */
/***********************************************************************
*
*               Module   : Inist
*               Fichier  : InistBhaKwd2Wicri.c
*               Auteur   : Ducloy
*               Date     : Mars 2013
*
************************************************************************
*
* Copyleft 2013 Jacques Ducloy 
* 
************************************************************************/
#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <ctype.h>
#include <getopt.h>
#include "TeiHandler.h"
#include "StrSearch.h"

SxmlNode *docInput;
Buffer *bufName;

StrSearchTable *personMatchingTable;
StrSearchTable *geoPascalMatchingTable;

int main (int argc, char **argv) {
  bufName=NewBuffer();

  BufferStrcpy(bufName, getenv("DILIB"));
  BufferStrcat(bufName, "/data/Inist/BhaPers.tab");
  personMatchingTable=StrSearchGetTable(BufferString(bufName), 100);

  BufferStrcpy(bufName, getenv("DILIB"));
  BufferStrcat(bufName, "/data/Inist/PascalGeo.tab");
  geoPascalMatchingTable=StrSearchGetTable(BufferString(bufName), 100);

  while ((docInput=SxmlInputNextDocumentElement()))
     {   
       SxmlNode *inputKW;
       SxmlNode *inputTermNode;
       TeiHandlerInit(docInput);
       inputKW=TeiFindKeywords("BHA", NULL, NULL, "fr");
       if (inputKW)
	 {
	   SxmlReset(inputKW);
	   while ((inputTermNode=SxmlNextNode(inputKW)))
	     {
	       char *inputTerm;
	       char *posPar;
	       char *posComma1;
	       char *posComma2;
	       char *termInTable;

	       inputTerm=SxmlLeafText(inputTermNode);

	       /*
	                                                                	 persons */
	       termInTable=StrSearch(personMatchingTable, inputTerm);

	       if(termInTable)
		 {
		   TeiKeywordsPutTerm("Wicri", "person", NULL, "fr", termInTable);
		 }
	       else
		 {
		   posPar=strchr(inputTerm,'(');
		   if ((!posPar) 
		       &&(posComma1=strchr(inputTerm,',')))
		     {
		       /*if (!posComma1) continue;*/
		       posComma2=strchr(posComma1+1,',');
		       if (!posComma2) continue;
		       if ((posComma2[1])!=' ') continue;
		       if ((isdigit(posComma2[2]))
			   ||(strncmp(posComma2,", v.",4)==0)
			   ||(strncmp(posComma2,", act.",6)==0))
			 {
			   BufferStrncpy(bufName, posComma1+2, posComma2-posComma1-2);
			   BufferStrcat(bufName, " ");
			   BufferStrncat(bufName, inputTerm, posComma1-inputTerm);
			   TeiKeywordsPutTerm("Wicri", "person", NULL, "fr", BufferString(bufName));
			 }
		     }
		 }
	       /*
		 geographic */
	       termInTable=StrSearch(geoPascalMatchingTable, inputTerm);
	       
	       if(termInTable)
		 {
		   TeiKeywordsPutTerm("Wicri", "geographic", NULL, "fr", termInTable);
		   continue;
		 }
	     }
	 }
       SxmlPrint (SxmlInputRecord);
     }
  exit (EXIT_SUCCESS);
}
