/**********************************************************************
*
*  projet   : DilibPro
*  module   : SgmlPath
*  fichier  : SgmlPathList.c
*  Auteur   : Jacques DUCLOY
*  Date     : Mai 94
*********************************************************************************
*
* Copyright (c) 1994 CNRS/CRIN & INRIA Lorraine
* 
***********************************************************************/

#include "SgmlPath.h"
#include <string.h>

struct SgmlPathElemList_struct *SgmlPathElemList_Create(str)
     char *str;
{
  struct SgmlPathElemList_struct *s1;
  s1 = (struct SgmlPathElemList_struct *) 
    malloc(sizeof(struct SgmlPathElemList_struct));
  s1->prev=NULL;
  s1->next=NULL;
  s1->prog=SgmlPathCompile(str);
  s1->iter=SgmlPathIteratorCreate(s1->prog);
  return s1;
}



SgmlPathList *SgmlPathList_Create()
{
  SgmlPathList *lz1;
  lz1=(SgmlPathList *)malloc(sizeof(SgmlPathList));
  lz1->first=NULL;
  lz1->last=NULL;
  lz1->current=NULL;
  lz1->root=NULL;
  return lz1;
}
/*                 ******************* A FAIRE      */
void SgmlPathList_Free(lz1)
     SgmlPathList *lz1;
{
  free(lz1);
}


SgmlPathList *SgmlPathList_FromString(s1)
char *s1;
{
  SgmlPathList *lz1;
  char *beginStr;
  static Buffer *bufPath=NULL;
  char *pos;
  if(!bufPath)bufPath=BufferCreate(10,10);
  lz1=SgmlPathList_Create();
  beginStr=s1;
  pos=NULL;
  do
    {
      while(beginStr[0]==' ')beginStr++;
      pos=strchr(beginStr,' ');
      if (pos)
	{
	  BufferStrncpy(bufPath, beginStr, pos-beginStr);
	  SgmlPathList_Insert(lz1, BufferString(bufPath));
	  beginStr=pos+1;
	}
      else
	{
	  SgmlPathList_Insert(lz1,beginStr);
	}
    }while (pos);
  return lz1;
}

SgmlPathList *SgmlPathList_Insert(lz1,re1)
     SgmlPathList *lz1;
     char *re1;
{
  struct SgmlPathElemList_struct *e1;
  e1=SgmlPathElemList_Create(re1);
  if(lz1->first)
{
  e1->prev=lz1->last;
  lz1->last->next=e1;
  lz1->last=e1;
}
else
{
  lz1->first=e1;
  lz1->last=e1;
}
return lz1;
}

SgmlPathList *SgmlPathList_Init(lz1,n1)
SgmlPathList *lz1;
SgmlNode     *n1;
{
  lz1->root=n1;
  if(lz1->first)
    {
      lz1->current=lz1->first;
      SgmlPathIteratorInit(lz1->current->iter,lz1->root);
    }
  return lz1;
}

SgmlNode *SgmlPathList_Next(lz1)
SgmlPathList *lz1;
{
  SgmlNode *n1;
  if(lz1)
    {
      if(lz1->current)
	{
	  if((n1=SgmlPathNext(lz1->current->iter)))
	    {
	      return n1;
	    }
	  else
	    {
	      if((lz1->current=lz1->current->next))
		{
		  SgmlPathIteratorInit(lz1->current->iter,lz1->root);
		  return SgmlPathList_Next(lz1);
		}
	      return NULL;
	    }
	}
      return NULL;
    }
  return NULL;
}

int getopt();
extern char *optarg;
extern int optind;
    
SgmlPathList *SgmlPathList_GetOpt(lz1,argc,argv)
     SgmlPathList *lz1;
     char **argv;
     int argc;
{
  char *nextOptArg;

  SgmlPathList_Insert(lz1,optarg);
  while((nextOptArg=argv[optind]))
    {
      if(nextOptArg[0]=='-')return NULL;
      else
	{
	  optind++;
	  SgmlPathList_Insert(lz1,nextOptArg);
	}
    }
  return lz1;
}


