#
#   Module  : SxPath
#   Fichier : SxPath.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/SxPath.mod:  $(DILIB)/Date/SxPath.include      \
                                 $(DILIB)/Date/SxPath.lib    \
                                 $(DILIB)/Date/SxPath.bin
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/SxPath.include: $(DILIB)/include/SxPath.h      \
                              $(DILIB)/include/SxmlSelect.h
	$(TOUCH)

$(DILIB)/include/SxPath.h:  $(DILIB_IMPORT)/SxPath/SxPath.h   \
                             $(DILIB)/include/SxmlNode.h      \
                             $(DILIB)/include/SxmlProcessor.h 
	cp  $(DILIB_IMPORT)/SxPath/SxPath.h $@

$(DILIB)/include/SxmlSelect.h:$(DILIB_IMPORT)/SxPath/SxmlSelect.h \
                             $(DILIB_IMPORT)/SxPath/SxPath.h      \
                             $(DILIB)/include/SxmlNode.h          \
                             $(DILIB)/include/SxmlDomProc.h       \
                             $(DILIB)/include/SxmlC.h             \
                             $(DILIB)/include/SxmlProcessor.h 
	cp  $(DILIB_IMPORT)/SxPath/SxmlSelect.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/SxPath.lib:$(DILIB)/Date/SxPathTools.o           \
                              $(DILIB)/Date/SxPathKernel.o     \
                              $(DILIB)/Date/SxPathAxis.o       \
                              $(DILIB)/Date/SxPathEval.o       \
                              $(DILIB)/Date/SxPathExpr.o       \
                              $(DILIB)/Date/SxmlSelectTools.o  \
                              $(DILIB)/Date/SxmlNode.lib       \
                              $(DILIB)/Date/SxPathEvalTools.o  \
                              $(DILIB)/Date/SxPathEvalFirst.o  \
                              $(DILIB)/Date/SxPathEasy.o       \
                              $(DILIB)/Date/SxmlProc.lib
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/SxPathTools.o:$(DILIB_IMPORT)/SxPath/SxPathTools.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathTools.c -Wall -I$(DILIB)/include   \
	                                             -c -o SxPathTools.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathTools.o
	$(TOUCH)
 
$(DILIB)/Date/SxPathKernel.o:$(DILIB_IMPORT)/SxPath/SxPathKernel.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathKernel.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathKernel.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathKernel.o
	$(TOUCH)

$(DILIB)/Date/SxPathEvalFirst.o:$(DILIB_IMPORT)/SxPath/SxPathEvalFirst.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathEvalFirst.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathEvalFirst.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathEvalFirst.o
	$(TOUCH)

$(DILIB)/Date/SxPathEasy.o:$(DILIB_IMPORT)/SxPath/SxPathEasy.c  \
                          $(DILIB)/include/SxPath.h             \
                          $(DILIB)/include/StrDict.h 
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathEasy.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathEasy.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathEasy.o
	$(TOUCH)

$(DILIB)/Date/SxPathEvalTools.o:$(DILIB_IMPORT)/SxPath/SxPathEvalTools.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathEvalTools.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathEvalTools.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathEvalTools.o
	$(TOUCH)

 
$(DILIB)/Date/SxPathAxis.o:$(DILIB_IMPORT)/SxPath/SxPathAxis.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathAxis.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathAxis.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathAxis.o
	$(TOUCH)

$(DILIB)/Date/SxPathEval.o:$(DILIB_IMPORT)/SxPath/SxPathEval.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathEval.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathEval.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathEval.o
	$(TOUCH)

$(DILIB)/Date/SxPathExpr.o:$(DILIB_IMPORT)/SxPath/SxPathExpr.c  \
                                   $(DILIB)/include/SxPath.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxPathExpr.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxPathExpr.o 
	ar ruv $(DILIB)/lib/libDilib.a SxPathExpr.o
	$(TOUCH)

$(DILIB)/Date/SxmlSelectTools.o: $(DILIB_IMPORT)/SxPath/SxmlSelectTools.c \
                                      $(DILIB)/include/SxmlSelect.h
	$(CC) $(DILIB_IMPORT)/SxPath/SxmlSelectTools.c   -Wall  -I$(DILIB)/include   \
	                                             -c -o SxmlSelectTools.o
	ar ruv $(DILIB)/lib/libDilib.a SxmlSelectTools.o
	$(TOUCH)

#------------------------------------------------------------------
# Les binaires
#
$(DILIB)/Date/SxPath.bin:$(DILIB)/bin/SxmlCut  \
                               $(DILIB)/bin/SxmlSelect \
                               $(DILIB)/bin/SxPathTestOnePath
	$(TOUCH)

$(DILIB)/bin/SxmlCut: $(DILIB_IMPORT)/SxPath/SxmlCut.c   \
                    $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/SxPath/SxmlCut.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/SxmlSelect: $(DILIB_IMPORT)/SxPath/SxmlSelect.c   \
                    $(DILIB)/Date/SxPath.lib           \
                    $(DILIB)/Date/SxmlProc.lib 
	$(CC)  $(DILIB_IMPORT)/SxPath/SxmlSelect.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/SxPathTestOnePath: $(DILIB_IMPORT)/SxPath/SxPathTestOnePath.c   \
                    $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/SxPath/SxPathTestOnePath.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@










