.TH XmlNodeList 3 "11 Jul 2003" \" -*- nroff -*- $Id: XmlNodeList.3.man,v 1.2 2003/07/11 14:44:34 parmentf Exp $
.ad l
.nh
.SH NAME
SxmlNodeList \- Functions for SxmlNodeList handling. 

.SH SYNOPSIS
.br
.PP
.nf
#include "SxmlNode.h"
.fi
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "SxmlNode * \fBSxmlNodeListCreate\fP ()"
.br
.ti -1c
.RI "SxmlNode * \fBSxmlNodeListAppend\fP (SxmlNode *l1, SxmlNode *n1)"
.br
.ti -1c
.RI "SxmlNode * \fBSxmlNodeListNextNode\fP (SxmlNode *l1)"
.br
.ti -1c
.RI "SxmlNode * \fBSxmlNodeListLastItem\fP (SxmlNode *l1)"
.br
.ti -1c
.RI "SxmlNode * \fBSxmlNodeListFreeLast\fP (SxmlNode *l1)"
.br
.in -1c
.SH "DESCRIPTION"
.PP 
Functions for SxmlNodeList handling.

An SxmlNodeList is a list of SxmlNode (that is to say a list of SxmlNodePointers). So, the children of an SxmlNodeList are SxmlNodePointers.
.PP

.SS "SxmlNode* SxmlNodeListAppend (SxmlNode * l1, SxmlNode * n1)"
.PP
Appends \fIn1\fP to \fIl1\fP.
.PP
\fBParameters:\fP
.RS 4
\fIl1\fP list to which to append \fIn1\fP 
.br
\fIn1\fP node to append to \fIl1\fP 
.RE
.PP
\fBReturns:\fP
.RS 4
\fIn1\fP (the node appended) 
.RE
.SS "SxmlNode* SxmlNodeListCreate ()"
.PP
Creates an SxmlNodeList
.PP
Creates an SxmlNode having \fCXML_NODE_NODE_LIST\fP as a type.
.PP
\fBReturns:\fP
.RS 4
the created SxmlNodeList 
.RE
.PP
\fBWarning:\fP
.RS 4
the returned SxmlNodeList has to be freed. 
.RE
.SS "SxmlNode* SxmlNodeListFreeLast (SxmlNode * l1)"
.PP
Frees the last item of \fIl1\fP.
.PP
\fBParameters:\fP
.RS 4
\fIl1\fP the SxmlNodeList 
.RE
.PP
\fBReturns:\fP
.RS 4
the last node of \fIl1\fP 
.RE
.SS "SxmlNode* SxmlNodeListLastItem (SxmlNode * l1)"
.PP
Gives the last item of \fIl1\fP, the SxmlNodeList.
.PP
\fBParameters:\fP
.RS 4
\fIl1\fP the SxmlNodeList 
.RE
.PP
\fBReturns:\fP
.RS 4
the last item of \fIl1\fP 
.RE
.SS "SxmlNode* SxmlNodeListNextNode (SxmlNode * l1)"
.PP
Gives the next node in \fIl1\fP.
.PP
Use this function to go through to whole list of nodes. Before going through the nodes, a SxmlReset is needed on \fIl1\fP.
.PP
Example: 
.PP
.nf
   SxmlReset(nl);
   while((node = SxmlNodeListNextNode(nl))) {
     ...  Use node 
   }

.PP
.PP
\fBParameters:\fP
.RS 4
\fIl1\fP list to go through (SxmlNodeList *) 
.RE
.PP
\fBReturns:\fP
.RS 4
the next node in \fIl1\fP 
.RE
.PP
\fBSee also:\fP
.RS 4
.BR SxmlReset (3)
.RE
.PP

.SH FILES
$DILIB_ROOT/Import/DilibSxml/SxmlNode/Source/SxmlNodeList.c

.SH "SEE ALSO"
.BR SxmlReset (3),
.BR SxmlContainerPointerCreate (3).

.SH "AUTHOR"
.PP 
(c) 2000-2003 INIST-CNRS

J.DUCLOY
F.PARMENTIER
<DilibMaster@inist.fr>

