/*   -*- coding: utf-8 -*-  */
/**********************************************************************
*
*      Programme de démonstration pour les outils de construction
*      de commandes avec interprétation
*
***********************************************************************/

#include "SxmlProcessor.h"
#include "SxmlDomProc.h"
#include <stdlib.h>

int main()
{
  SxmlMemory    *mem1;
  SxmlProcessor *p1;
  SxmlElement   *step;
  SxmlElement   *result;

  mem1 =SxmlMemoryCreate();         /*  création d'une mémoire */
  p1   =SxmlProcessorCreate(mem1);  /*  création d'un processor sur cette mémoire */

  SxmlDomMemoryInit(mem1);          /*  mise en mémoire des fonctions implémentant DOM */

  /*  On initialise l'élément step avec un script xml dans lequel on appelle fisrtChild
      sur un l'élément xml mess qui contient le texte Hello World
  */
  step=SxmlFromString("<dom:firstChild><mess>Hello World</mess></dom:firstChild>");

  result= SxmlProcessorEvalToNode(p1,step);      /* évaluation de step   */
      
  SxmlPrint(result);                             /* imprime : Hello World  */
  putchar ('\n');
	
  exit (0);
}
