
#   Module  : Tei
#   Fichier : Tei.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Tei.mod: $(DILIB)/Date/Tei.include \
                       $(DILIB)/Date/Tei.php     \
                       $(DILIB)/Date/Tei.lib     \
                       $(DILIB)/Date/Tei.bin     \
                       $(DILIB)/Date/Tei.data
	$(TOUCH)

#----------------------------------------------------------------
# include files
#
$(DILIB)/Date/Tei.include: $(DILIB)/include/TeiHandler.h \
                                  $(DILIB)/include/SvgPath.h    \
                                  $(DILIB)/include/GeoPath.h    \
                                  $(DILIB)/Date/SxPath.include
	$(TOUCH)

$(DILIB)/include/TeiHandler.h:  $(DILIB_IMPORT)/Tei/TeiHandler.h
	cp $(DILIB_IMPORT)/Tei/TeiHandler.h $@

$(DILIB)/include/SvgPath.h: $(DILIB_IMPORT)/Tei/SvgPath.h
	cp $(DILIB_IMPORT)/Tei/SvgPath.h $@

$(DILIB)/include/GeoPath.h: $(DILIB_IMPORT)/Tei/GeoPath.h \
                            $(DILIB)/include/SvgPath.h    
	cp $(DILIB_IMPORT)/Tei/GeoPath.h $@


#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Tei.php: $(DILIB)/php/Tei/TeiExplor.php
	$(TOUCH)

$(DILIB)/php/Tei/TeiExplor.php: $(DILIB_IMPORT)/Tei/TeiExplor.php
	cp $(DILIB_IMPORT)/Tei/TeiExplor.php $@

#----------------------------------------------------------------
# Dilib library
#

$(DILIB)/Date/Tei.lib:$(DILIB)/Date/TeiHandler.o         \
                             $(DILIB)/Date/TeiKeywords.o \
                             $(DILIB)/Date/SvgPath.o     \
                             $(DILIB)/Date/TeiAuthor.o   \
                             $(DILIB)/Date/TeiDoubles.o   \
                              $(DILIB)/Date/Utf8.lib     \
                             $(DILIB)/Date/TeiAffiliation.o 
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/TeiHandler.o: $(DILIB_IMPORT)/Tei/TeiHandler.c \
                                  $(DILIB)/Date/Tei.include \
                                  $(DILIB)/Date/Utf8.include \
                                  $(DILIB)/Date/SxPath.lib 
		$(CC) $(DILIB_IMPORT)/Tei/TeiHandler.c   -I$(DILIB)/include            \
	      -c -o TeiHandler.o
	ar ruv  $(DILIB)/lib/libDilib.a   TeiHandler.o
	$(TOUCH)

$(DILIB)/Date/SvgPath.o: $(DILIB_IMPORT)/Tei/SvgPath.c  \
                                $(DILIB)/Date/Tei.include
		$(CC) $(DILIB_IMPORT)/Tei/SvgPath.c    -I$(DILIB)/include            \
	      -c -o SvgPath.o
	ar ruv  $(DILIB)/lib/libDilib.a   SvgPath.o
	$(TOUCH)

$(DILIB)/Date/TeiKeywords.o: $(DILIB_IMPORT)/Tei/TeiKeywords.c \
                                  $(DILIB)/Date/Tei.include \
                                  $(DILIB)/Date/SxPath.lib 
		$(CC) $(DILIB_IMPORT)/Tei/TeiKeywords.c   -I$(DILIB)/include            \
	      -c -o TeiKeywords.o
	ar ruv  $(DILIB)/lib/libDilib.a   TeiKeywords.o
	$(TOUCH)

$(DILIB)/Date/TeiAffiliation.o: $(DILIB_IMPORT)/Tei/TeiAffiliation.c \
                                  $(DILIB)/Date/Tei.include \
                                  $(DILIB)/Date/SxPath.lib 
		$(CC) $(DILIB_IMPORT)/Tei/TeiAffiliation.c   -I$(DILIB)/include            \
	      -c -o TeiAffiliation.o
	ar ruv  $(DILIB)/lib/libDilib.a   TeiAffiliation.o
	$(TOUCH)

$(DILIB)/Date/TeiAuthor.o: $(DILIB_IMPORT)/Tei/TeiAuthor.c \
                                  $(DILIB)/Date/Tei.include \
                                  $(DILIB)/Date/SxPath.lib 
		$(CC) $(DILIB_IMPORT)/Tei/TeiAuthor.c   -I$(DILIB)/include            \
	      -c -o TeiAuthor.o
	ar ruv  $(DILIB)/lib/libDilib.a   TeiAuthor.o
	$(TOUCH)


$(DILIB)/Date/TeiDoubles.o: $(DILIB_IMPORT)/Tei/TeiDoubles.c \
                                  $(DILIB)/Date/Tei.include \
                                  $(DILIB)/Date/Utf8.include \
                                  $(DILIB)/Date/SxPath.lib 
		$(CC) $(DILIB_IMPORT)/Tei/TeiDoubles.c   -I$(DILIB)/include            \
	      -c -o TeiDoubles.o
	ar ruv  $(DILIB)/lib/libDilib.a   TeiDoubles.o
	$(TOUCH)

#------------------------------------------------------------------
# binary files
#

$(DILIB)/Date/Tei.bin: $(DILIB)/bin/TeiPutRefToIdno        \
                              $(DILIB)/bin/TeiRejectOnIdno        \
                              $(DILIB)/bin/TeiRejectOnKeywords    \
                              $(DILIB)/bin/TeiTableTermsFromGroup \
                              $(DILIB)/bin/TeiTableOrgFromWiki     \
                              $(DILIB)/bin/TeiTableTermsFromWiki  \
                              $(DILIB)/bin/TeiTableCityFromWiki  \
                              $(DILIB)/bin/TeiTablePersFromWiki  \
                              $(DILIB)/bin/TeiTableRegionFromWiki  \
                              $(DILIB)/bin/TeiGeoSvgFromWiki       \
                              $(DILIB)/bin/TeiCurationPers        \
                              $(DILIB)/bin/TeiKeywordsFromTable   \
                              $(DILIB)/bin/TeiPutLinkByRbid       \
                              $(DILIB)/bin/TeiListBiblio2MediaWikiTable     \
                              $(DILIB)/bin/TeiBuildAffiliationTree \
                              $(DILIB)/bin/TeiSplitWordUsual      \
                              $(DILIB)/bin/TeiMiniVocEngRules      \
                              $(DILIB)/bin/TeiAddKeywordsTermsFromTableRbid  
	$(TOUCH)

$(DILIB)/bin/TeiPutRefToIdno:$(DILIB_IMPORT)/Tei/TeiPutRefToIdno.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/Hfd.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiPutRefToIdno.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiSplitWordUsual:$(DILIB_IMPORT)/Tei/TeiSplitWordUsual.c  \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/Hfd.lib  \
                          $(DILIB)/Date/Utf8.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiSplitWordUsual.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiMiniVocEngRules:$(DILIB_IMPORT)/Tei/TeiMiniVocEngRules.c  \
                          $(DILIB)/Date/StrDict.lib  \
                          $(DILIB)/Date/Buffer.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiMiniVocEngRules.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiListBiblio2MediaWikiTable:$(DILIB_IMPORT)/Tei/TeiListBiblio2MediaWikiTable.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiListBiblio2MediaWikiTable.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTablePersFromWiki:$(DILIB_IMPORT)/Tei/TeiTablePersFromWiki.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiTablePersFromWiki.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/TeiPutLinkByRbid:$(DILIB_IMPORT)/Tei/TeiPutLinkByRbid.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiPutLinkByRbid.c  -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTableTermsFromWiki: $(DILIB_IMPORT)/Tei/TeiTableTermsFromWiki  \
                                    $(DILIB)/Date/MediaWiki.bin                \
                                    $(DILIB)/Date/SxmlNode.bin                \
                                    $(DILIB)/bin/TeiTableTermsFromGroup
	$(MAKE_SHELL) $(DILIB_IMPORT)/Tei/TeiTableTermsFromWiki $@

$(DILIB)/bin/TeiRejectOnIdno:$(DILIB_IMPORT)/Tei/TeiRejectOnIdno.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiRejectOnIdno.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTableTermsFromGroup:$(DILIB_IMPORT)/Tei/TeiTableTermsFromGroup.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiTableTermsFromGroup.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTableOrgFromWiki:$(DILIB_IMPORT)/Tei/TeiTableOrgFromWiki.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiTableOrgFromWiki.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiGeoSvgFromWiki:$(DILIB_IMPORT)/Tei/TeiGeoSvgFromWiki.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiGeoSvgFromWiki.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTableRegionFromWiki:$(DILIB_IMPORT)/Tei/TeiTableRegionFromWiki.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiTableRegionFromWiki.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiCurationPers:$(DILIB_IMPORT)/Tei/TeiCurationPers.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib \
                          $(DILIB)/Date/SxPath.lib 
	$(CC)  $(DILIB_IMPORT)/Tei/TeiCurationPers.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiBuildAffiliationTree:$(DILIB_IMPORT)/Tei/TeiBuildAffiliationTree.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib \
                          $(DILIB)/Date/SxPath.lib 
	$(CC)  $(DILIB_IMPORT)/Tei/TeiBuildAffiliationTree.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiTableCityFromWiki:$(DILIB_IMPORT)/Tei/TeiTableCityFromWiki.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiTableCityFromWiki.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiKeywordsFromTable:$(DILIB_IMPORT)/Tei/TeiKeywordsFromTable.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiKeywordsFromTable.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiRejectOnKeywords:$(DILIB_IMPORT)/Tei/TeiRejectOnKeywords.c \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiRejectOnKeywords.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/TeiAddKeywordsTermsFromTableRbid:$(DILIB_IMPORT)/Tei/TeiAddKeywordsTermsFromTableRbid.c  \
                          $(DILIB)/Date/Tei.lib  \
                          $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Tei/TeiAddKeywordsTermsFromTableRbid.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------------------------------------
# data
#

$(DILIB)/Date/Tei.data: $(DILIB)/data/Tei/TeiUnIndent.dict
	$(TOUCH)

$(DILIB)/data/Tei/TeiUnIndent.dict: $(DILIB_IMPORT)/Tei/Data/teiUnIndent.wiki   \
                                    $(DILIB)/bin/SxmlSelect                     \
                                    $(DILIB)/Date/MediaWiki.bin
	MediaWikiCleanTable   <   $(DILIB_IMPORT)/Tei/Data/teiUnIndent.wiki  \
          |  MediaWikiTable2SxmlRowCol                                       \
          |  MediaWikiTableTransformCol -T1                                  \
          |  SxmlSelect -s r/c1/i/1 -g r/c2/l/1 -p @s1 -p @g1                \
          |  sort > $@


#------------------------------- end Tei.mk ----------------
