%{
/****************************************************************************

     Projet   : External/TeX
     Module   : LaTeX
     Commande : LatexCsToSgml
     Fichier  : LatexCs2ToSgml.lex
     Auteur   : Ducloy
     Date     : 1/4/94

****************************************************************************/
%}

%START MATH
%%
"{\\c{c}}"            printf("&ccedil;");
"\\c{c}"              printf("&ccedil;");
\\oe[ ]               printf("&oelig;");
\{\\oe\}              printf("&oelig;");
"\\,:"                printf(" :");
"\\,;"                printf(" ;");
"\\,?"                printf(" ?");
\\\^\{\\i\}           printf("&icirc;");
\\\"\{\\i\}           printf("&iuml;");
\\\'\{\\i\}           printf("&iacute;");
\\\`\{\\i\}           printf("&igrave;");
\\\~\{\\i\}           printf("&itilde;");
\\\'\{[a-zA-Z]\}      printf("&%cacute;" , yytext[3]);
\\\`\{[a-zA-Z]\}      printf("&%cgrave;" , yytext[3]);
\\\^\{[a-zA-Z]\}      printf("&%ccirc;"  , yytext[3]);
\\\"\{[a-zA-Z]\}      printf("&%cuml;"   , yytext[3]);
\\\~\{[a-zA-Z]\}      printf("&%ctilde;" , yytext[3]);
\\H\{[a-zA-Z]\}       printf("&%cuml;"   , yytext[3]);
\\a\'\{[a-zA-Z]\}     printf("&%cacute;" , yytext[4]);
\\a\`\{[a-zA-Z]\}     printf("&%cgrave;" , yytext[4]);
\{\\\'[a-zA-Z]\}      printf("&%cacute;" , yytext[3]);
\{\\\`[a-zA-Z]\}      printf("&%cgrave;" , yytext[3]);
\{\\\^[a-zA-Z]\}      printf("&%ccirc;"  , yytext[3]);
\{\\\"[a-zA-Z]\}      printf("&%cuml;"   , yytext[3]);
\{\\\^\\[a-zA-Z]\}    printf("&%ccirc;"  , yytext[4]);
\{\\\"\\[a-zA-Z]\}    printf("&%cuml;"   , yytext[4]);
\\\'[a-zA-Z]          printf("&%cacute;" , yytext[2]);
\\\`[a-zA-Z]          printf("&%cgrave;" , yytext[2]);
\\\^[a-zA-Z]          printf("&%ccirc;"  , yytext[2]);
\$                    BEGIN MATH;
<MATH>\$              BEGIN 0;
<MATH>\\[Bb]eta             printf("&%cgr;"    , yytext[1]);
<MATH>\\[Dd]elta            printf("&%cgr;"    , yytext[1]);
<MATH>\\[Ll]ambda           printf("&%cgr;"    , yytext[1]);
<MATH>\\[Ss]igma            printf("&%cgr;"    , yytext[1]);
\\\&                  printf("&amp;");
\\\$                  printf("&dollar;");
\\\%                  printf("&percnt;");
\\\#                  printf("&num;");
\\\{                  printf("&lcub;");
\\\}                  printf("&rcub;");
\\\_                  printf("&lowbar;");
\&                    printf("&texamp;");
\<                    printf("&lt;");
\>                    printf("&gt;");
\\-                   ;
%%
int main()
{
  yylex();
  exit(0);
}
