#   Module  : Utf8
#   Fichier : Utf8.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Utf8.mod: $(DILIB)/Date/Utf8.include        \
                               $(DILIB)/Date/Utf8.lib     \
                               $(DILIB)/Date/Utf8.bin     \
                               $(DILIB)/Date/Utf8.data
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/Utf8.include:  $(DILIB)/include/Utf8Converter.h  \
                                    $(DILIB)/include/Utf8Text.h
	$(TOUCH)

$(DILIB)/include/Utf8Converter.h:  $(DILIB_IMPORT)/Utf8/Utf8Converter.h \
                                   $(DILIB)/include/Buffer.h
	cp  $(DILIB_IMPORT)/Utf8/Utf8Converter.h $@

$(DILIB)/include/Utf8Text.h:  $(DILIB_IMPORT)/Utf8/Utf8Text.h \
                                   $(DILIB)/include/Buffer.h
	cp  $(DILIB_IMPORT)/Utf8/Utf8Text.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/Utf8.lib:$(DILIB)/Date/Utf8Converter.o \
                             $(DILIB)/Date/Utf8ConverterName.o \
                             $(DILIB)/Date/Utf8Text.o         \
                             $(DILIB)/Date/Utf8Lang.o         \
                             $(DILIB)/Date/Utf8SplitText.o     \
                             $(DILIB)/Date/Utf8ConverterJumpToAlpha.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/Utf8Converter.o:$(DILIB_IMPORT)/Utf8/Utf8Converter.c \
                            $(DILIB)/include/Utf8Converter.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8Converter.c   -I$(DILIB)/include            \
	      -c -o Utf8Converter.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8Converter.o
	$(TOUCH)

$(DILIB)/Date/Utf8Text.o:$(DILIB_IMPORT)/Utf8/Utf8Text.c \
                            $(DILIB)/include/Utf8Text.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8Text.c   -I$(DILIB)/include            \
	      -c -o Utf8Text.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8Text.o
	$(TOUCH)

$(DILIB)/Date/Utf8Lang.o:$(DILIB_IMPORT)/Utf8/Utf8Lang.c \
                            $(DILIB)/include/Utf8Text.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8Lang.c   -I$(DILIB)/include            \
	      -c -o Utf8Lang.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8Lang.o
	$(TOUCH)


$(DILIB)/Date/Utf8SplitText.o:$(DILIB_IMPORT)/Utf8/Utf8SplitText.c \
                            $(DILIB)/include/Utf8Text.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8SplitText.c   -I$(DILIB)/include            \
	      -c -o Utf8SplitText.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8SplitText.o
	$(TOUCH)

$(DILIB)/Date/Utf8ConverterName.o:$(DILIB_IMPORT)/Utf8/Utf8ConverterName.c \
                            $(DILIB)/include/Utf8Converter.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8ConverterName.c   -I$(DILIB)/include            \
	      -c -o Utf8ConverterName.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8ConverterName.o
	$(TOUCH)

$(DILIB)/Date/Utf8ConverterJumpToAlpha.o:$(DILIB_IMPORT)/Utf8/Utf8ConverterJumpToAlpha.c \
                            $(DILIB)/include/Utf8Converter.h \
                            $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Utf8/Utf8ConverterJumpToAlpha.c   -I$(DILIB)/include            \
	      -c -o Utf8ConverterJumpToAlpha.o
	ar ruv  $(DILIB)/lib/libDilib.a   Utf8ConverterJumpToAlpha.o
	$(TOUCH)

#------------------------------------------------------------------
# binaries (or executables)
#

$(DILIB)/Date/Utf8.bin:$(DILIB)/bin/Utf8FromHexEntity         \
                              $(DILIB)/bin/Utf8FromIsoLat1Entity     \
                              $(DILIB)/bin/Utf8FromDecimalEntity     \
                              $(DILIB)/bin/Utf8IndexPhpFilter        \
                              $(DILIB)/bin/Utf8SplitWordUsual        \
                              $(DILIB)/bin/Utf8StopWordsDictFromWiki \
                              $(DILIB)/bin/Utf8LangBuildProfile       \
                              $(DILIB)/bin/Utf8ToLc
	$(TOUCH)

$(DILIB)/bin/Utf8FromHexEntity: $(DILIB_IMPORT)/Utf8/Utf8FromHexEntity.lex \
                $(DILIB)/Date/Buffer.lib
	$(LEX) $(DILIB_IMPORT)/Utf8/Utf8FromHexEntity.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/Utf8ToLc: $(DILIB_IMPORT)/Utf8/Utf8ToLc.c \
                $(DILIB)/Date/Buffer.lib   \
                $(DILIB)/Date/Utf8.lib 
	$(CC)  $(DILIB_IMPORT)/Utf8/Utf8ToLc.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o  $@

$(DILIB)/bin/Utf8FromIsoLat1Entity:$(DILIB_IMPORT)/Utf8/Utf8FromIsoLat1Entity.lex \
                $(DILIB)/Date/Buffer.lib
	$(LEX) $(DILIB_IMPORT)/Utf8/Utf8FromIsoLat1Entity.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/Utf8FromDecimalEntity:$(DILIB_IMPORT)/Utf8/Utf8FromDecimalEntity.lex \
                $(DILIB)/Date/Buffer.lib
	$(LEX) $(DILIB_IMPORT)/Utf8/Utf8FromDecimalEntity.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/Utf8LangBuildProfile:$(DILIB_IMPORT)/Utf8/Utf8LangBuildProfile.lex \
                $(DILIB)/Date/StrDict.lib
	$(LEX) $(DILIB_IMPORT)/Utf8/Utf8LangBuildProfile.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/Utf8IndexPhpFilter: $(DILIB_IMPORT)/Utf8/Utf8IndexPhpFilter.lex \
                $(DILIB)/Date/Buffer.lib
	$(LEX) $(DILIB_IMPORT)/Utf8/Utf8IndexPhpFilter.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/Utf8SplitWordUsual:  $(DILIB_IMPORT)/Utf8/Utf8SplitWordUsual.c \
                $(DILIB)/Date/Buffer.lib   \
                $(DILIB)/Date/Utf8.lib 
	$(CC)  $(DILIB_IMPORT)/Utf8/Utf8SplitWordUsual.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o  $@

$(DILIB)/bin/Utf8StopWordsDictFromWiki: $(DILIB_IMPORT)/Utf8/Utf8StopWordsDictFromWiki  \
                                        $(DILIB)/bin/SxmlSelect                         \
                                        $(DILIB)/Date/MediaWiki.bin
	$(MAKE_SHELL)  $(DILIB_IMPORT)/Utf8/Utf8StopWordsDictFromWiki  $@

#------------------------------------------------------------------
# data
#

$(DILIB)/Date/Utf8.data: $(DILIB)/data/Utf8/enStopWords.dict \
                         $(DILIB)/data/Utf8/frStopWords.dict
	$(TOUCH)

$(DILIB)/data/Utf8/enStopWords.dict:$(DILIB_IMPORT)/Utf8/Data/Utf8StopWordEn.wiki \
                                    $(DILIB)/bin/Utf8StopWordsDictFromWiki
	$(DILIB)/bin/Utf8StopWordsDictFromWiki < $(DILIB_IMPORT)/Utf8/Data/Utf8StopWordEn.wiki > $@

$(DILIB)/data/Utf8/frStopWords.dict:$(DILIB_IMPORT)/Utf8/Data/Utf8StopWordFr.wiki \
                                    $(DILIB)/bin/Utf8StopWordsDictFromWiki
	$(DILIB)/bin/Utf8StopWordsDictFromWiki < $(DILIB_IMPORT)/Utf8/Data/Utf8StopWordFr.wiki > $@

#------------------------- end Utf8.mk -------------------------------------------
