/*   -*- coding: utf-8 -*-  */

/***********************************************************************
*
*        Module   : Utf8
*        Fichier  : Utf8SplitUsual.c
*        Auteur   : J. DUCLOY
*        Date     : octobre 2014
*
************************************************************************/

#include "Utf8Text.h"
#include "Utf8Converter.h"
#include "SxmlNode.h"
#include "StrDict.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

StrDict *Utf8SplitStopWordDict=NULL;
int      Utf8LowerCaseMode;

int getopt();
extern char *optarg;

int main(int argc, char **argv)
{
  char cOption;
  char   *line;
  Buffer *bufLine;
  Buffer *bufText;
  char tabChar;
  int minLength;

  tabChar='\t';
  minLength=2;
  Utf8LowerCaseMode=0;
  bufLine=NewBuffer();
  bufText=NewBuffer();
  while((cOption=getopt(argc,argv,"lm:T:s:S:"))!=EOF)
    {
      switch(cOption)
	{
	case 'l':
	  Utf8LowerCaseMode=1;
	  break;
	case 'T':
	  tabChar=*optarg;
	  break;
	case 'm':
	  minLength=atoi(optarg);
	  break;
	case 's':
	  if (!Utf8SplitStopWordDict) Utf8SplitStopWordDict=NewStrDict();
	  StrDictAddNewDatum(Utf8SplitStopWordDict, optarg, optarg);
	  break;
	case 'S':
	  Utf8SplitStopWordDict=StrDictFromFile(optarg);
	  break;
	}
    }
  while ((line=BufferGets(bufLine))) 
    {
      char *posTabulation;
      char *toParse;
      char *word;
      posTabulation=strchr(line, tabChar);
      BufferStrncpy(bufText, line, posTabulation-line);
      toParse=BufferString(bufText);
      while ((word=Utf8GetAlphaString(toParse, &toParse, 0)))
	{
	  char *targetWord;
	  if (Utf8Length(word)<minLength) continue;
	  if (Utf8LowerCaseMode) targetWord=Utf8StringToLower(word);
	  else targetWord=word;
      
	  if (Utf8SplitStopWordDict)
	    {
	      if ( StrDictSearch(Utf8SplitStopWordDict, targetWord)) continue;
	    }
	  printf("%s\t%s\n",targetWord, posTabulation+1);
	}
    }
}

