#
#   Module  : Wicri
#   Fichier : Wicri.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/Wicri.mod:$(DILIB)/Date/Wicri.bin     \
                               $(DILIB)/Date/Wicri.include \
                               $(DILIB)/Date/Wicri.lib     \
                               $(DILIB)/Date/Wicri.php     \
                               $(DILIB)/Date/Wicri.data
	$(TOUCH)

#----------------------------------------------------------------
# include files
#
$(DILIB)/Date/Wicri.include: $(DILIB)/include/Wicri.h     \
                             $(DILIB)/include/WicriFrance.h      \
                             $(DILIB)/include/WicriAllemagne.h   \
                             $(DILIB)/include/WicriBelgique.h    \
                             $(DILIB)/include/WicriBresil.h      \
                             $(DILIB)/include/WicriAmerique.h    \
                             $(DILIB)/include/WicriPaysFromEn.h  \
                             $(DILIB)/include/WicriPostalCodes.h \
                             $(DILIB)/include/WicriRegionFromEn.h 
	$(TOUCH)

$(DILIB)/include/Wicri.h: $(DILIB_IMPORT)/Wicri/Wicri.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/StrDict.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/Wicri.h $@

$(DILIB)/include/WicriFrance.h: $(DILIB_IMPORT)/Wicri/WicriFrance.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriFrance.h $@

$(DILIB)/include/WicriPostalCodes.h: $(DILIB_IMPORT)/Wicri/WicriPostalCodes.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriPostalCodes.h $@


$(DILIB)/include/WicriAllemagne.h: $(DILIB_IMPORT)/Wicri/WicriAllemagne.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriAllemagne.h $@

$(DILIB)/include/WicriBresil.h: $(DILIB_IMPORT)/Wicri/WicriBresil.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriBresil.h $@

$(DILIB)/include/WicriBelgique.h: $(DILIB_IMPORT)/Wicri/WicriBelgique.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriBelgique.h $@


$(DILIB)/include/WicriAmerique.h: $(DILIB_IMPORT)/Wicri/WicriAmerique.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriAmerique.h $@


$(DILIB)/include/WicriPaysFromEn.h:$(DILIB_IMPORT)/Wicri/WicriPaysFromEn.h \
               $(DILIB)/Date/StrSearch.include \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriPaysFromEn.h $@

$(DILIB)/include/WicriRegionFromEn.h:$(DILIB_IMPORT)/Wicri/WicriRegionFromEn.h \
              $(DILIB_IMPORT)/Wicri/WicriPaysFromEn.h \
               $(DILIB)/Date/StrSearch.include \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Wicri/WicriRegionFromEn.h $@

#----------------------------------------------------------------
# Dilib library
#

$(DILIB)/Date/Wicri.lib:  $(DILIB)/Date/WicriTools.o         \
                    $(DILIB)/Date/WicriFranceTools.o         \
                    $(DILIB)/Date/WicriAllemagneTools.o      \
                    $(DILIB)/Date/WicriAmeriqueTools.o       \
                    $(DILIB)/Date/WicriBresilTools.o         \
                    $(DILIB)/Date/WicriEspagneTools.o        \
                    $(DILIB)/Date/WicriOldIsoTools.o         \
                    $(DILIB)/Date/WicriPaysFromEn.o          \
                    $(DILIB)/Date/WicriUnivTools.o           \
                    $(DILIB)/Date/WicriPostalCodesTools.o    \
                    $(DILIB)/Date/WicriRegionFromEn.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/WicriTools.o:$(DILIB_IMPORT)/Wicri/WicriTools.c \
                                $(DILIB/Date/StrDict.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriTools.c -Wall  -I$(DILIB)/include            \
	      -c -o WicriTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriTools.o
	$(TOUCH)

$(DILIB)/Date/WicriFranceTools.o:$(DILIB_IMPORT)/Wicri/WicriFranceTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriFranceTools.c -Wall  -I$(DILIB)/include            \
	      -c -o WicriFranceTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriFranceTools.o
	$(TOUCH)

$(DILIB)/Date/WicriUnivTools.o:$(DILIB_IMPORT)/Wicri/WicriUnivTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriUnivTools.c -Wall  -I$(DILIB)/include            \
	      -c -o WicriUnivTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriUnivTools.o
	$(TOUCH)

$(DILIB)/Date/WicriAllemagneTools.o:$(DILIB_IMPORT)/Wicri/WicriAllemagneTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriAllemagneTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriAllemagneTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriAllemagneTools.o
	$(TOUCH)

$(DILIB)/Date/WicriBresilTools.o:$(DILIB_IMPORT)/Wicri/WicriBresilTools.c \
                                $(DILIB/Date/StrDict.lib     \
                                $(DILIB/Date/SxmlNode.lib    \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriBresilTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriBresilTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriBresilTools.o
	$(TOUCH)


$(DILIB)/Date/WicriPostalCodesTools.o:$(DILIB_IMPORT)/Wicri/WicriPostalCodesTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriPostalCodesTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriPostalCodesTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriPostalCodesTools.o
	$(TOUCH)

$(DILIB)/Date/WicriEspagneTools.o:$(DILIB_IMPORT)/Wicri/WicriEspagneTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriEspagneTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriEspagneTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriEspagneTools.o
	$(TOUCH)

$(DILIB)/Date/WicriAmeriqueTools.o:$(DILIB_IMPORT)/Wicri/WicriAmeriqueTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriAmeriqueTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriAmeriqueTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriAmeriqueTools.o
	$(TOUCH)

$(DILIB)/Date/WicriOldIsoTools.o:$(DILIB_IMPORT)/Wicri/WicriOldIsoTools.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib  \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriOldIsoTools.c  -Wall -I$(DILIB)/include            \
	      -c -o WicriOldIsoTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriOldIsoTools.o
	$(TOUCH)


$(DILIB)/Date/WicriPaysFromEn.o:$(DILIB_IMPORT)/Wicri/WicriPaysFromEn.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib     \
                                $(DILIB/Date/SxmlNode.lib    \
                                $(DILIB/Date/Utf8.lib    \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriPaysFromEn.c   -I$(DILIB)/include     -Wall       \
	      -c -o WicriPaysFromEn.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriPaysFromEn.o
	$(TOUCH)


$(DILIB)/Date/WicriRegionFromEn.o:$(DILIB_IMPORT)/Wicri/WicriRegionFromEn.c \
                                $(DILIB/Date/StrSearch.lib  \
                                $(DILIB/Date/Buffer.lib     \
                                $(DILIB/Date/SxmlNode.lib    \
                                $(DILIB/Date/Utf8.lib    \
                               $(DILIB)/Date/Wicri.include
		$(CC) $(DILIB_IMPORT)/Wicri/WicriRegionFromEn.c   -I$(DILIB)/include     -Wall       \
	      -c -o WicriRegionFromEn.o
	ar ruv  $(DILIB)/lib/libDilib.a   WicriRegionFromEn.o
	$(TOUCH)


#----------------------------------------------------------------
# Les binaires
#
$(DILIB)/Date/Wicri.bin:  $(DILIB)/bin/WicriGetPage                 \
                                 $(DILIB)/bin/WicriBiblioCsv2CorpusTei     \
                                 $(DILIB)/bin/WicriBiblioExplorDataShells  \
                                 $(DILIB)/bin/WicriExplorSiteShell         \
                                 $(DILIB)/bin/WicriTableOrgFromWiki        \
                                 $(DILIB)/bin/WicriTableRegionFromWiki     \
                                 $(DILIB)/bin/WicriGrandeRegionExtract     \
                                 $(DILIB)/bin/WicriBiblioExplorSite        \
                                 $(DILIB)/bin/WicriExpandApiFromList       \
                                 $(DILIB)/bin/WicriStatistiquesSite
	$(TOUCH)

$(DILIB)/bin/WicriGetPage: $(DILIB_IMPORT)/Wicri/WicriGetPage.c  \
                        $(DILIB)/Date/CharSetBuffer.lib           \
                        $(DILIB)/Date/StrDict.lib           \
                       $(DILIB)/Date/Wicri.lib
	$(CC) $(DILIB_IMPORT)/Wicri/WicriGetPage.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/WicriExpandApiFromList: $(DILIB_IMPORT)/Wicri/WicriExpandApiFromList.c  \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Wicri/WicriExpandApiFromList.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/WicriStatistiquesSite: $(DILIB_IMPORT)/Wicri/WicriStatistiquesSite.c  \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Wicri/WicriStatistiquesSite.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/WicriTableOrgFromWiki: $(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriTableOrgFromWiki \
                            $(DILIB)/Date/Tei.bin                    \
                           $(DILIB)/Date/MediaWiki.bin
	$(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriTableOrgFromWiki $@

$(DILIB)/bin/WicriTableRegionFromWiki: $(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriTableRegionFromWiki \
                            $(DILIB)/Date/Tei.bin                    \
                           $(DILIB)/Date/MediaWiki.bin
	$(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriTableRegionFromWiki $@

$(DILIB)/bin/WicriGrandeRegionExtract: $(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriGrandeRegionExtract \
                            $(DILIB)/Date/SxmlNode.bin                    \
                           $(DILIB)/Date/Hfd.bin
	$(MAKE_SHELL) $(DILIB_IMPORT)/Wicri/WicriGrandeRegionExtract $@


$(DILIB)/bin/WicriExplorSiteShell: $(DILIB_IMPORT)/Wicri/WicriExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Wicri/WicriExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/WicriBiblioCsv2CorpusTei:$(DILIB_IMPORT)/Wicri/WicriBiblioCsv2CorpusTei.c \
                                  $(DILIB)/Date/SxPath.lib         \
                                  $(DILIB)/Date/Utf8.lib                    \
                                   $(DILIB)/Date/Tei.lib     
	$(CC) $(DILIB_IMPORT)/Wicri/WicriBiblioCsv2CorpusTei.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a   -o $@

$(DILIB)/bin/WicriBiblioExplorDataShells: $(DILIB_IMPORT)/Wicri/WicriBiblioExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC) $(DILIB_IMPORT)/Wicri/WicriBiblioExplorDataShells.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a   -o $@

$(DILIB)/bin/WicriBiblioExplorSite: $(DILIB_IMPORT)/Wicri/WicriBiblioExplorSite.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC) $(DILIB_IMPORT)/Wicri/WicriBiblioExplorSite.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

#----------------------------------------------------------------
# Les données
#
#                                  $(DILIB)/Date/WicriBois.data                        


$(DILIB)/Date/Wicri.data:  $(DILIB)/data/Wicri/interwiki.tab                       \
                                  $(DILIB)/Date/WicriAllemagne.data                \
                                  $(DILIB)/Date/WicriBelgique.data                 \
                                  $(DILIB)/Date/WicriBresil.data                   \
                                  $(DILIB)/Date/WicriEspagne.data                  \
                                  $(DILIB)/Date/WicriEurope.data                   \
                                  $(DILIB)/Date/WicriFrance.data                   \
                                  $(DILIB)/Date/WicriLorraine.data                 \
                                  $(DILIB)/Date/WicriMetadata.data                 \
                                  $(DILIB)/Date/WicriAmerique.data                   \
                                  $(DILIB)/Date/WicriAfrique.data                    \
                                  $(DILIB)/Date/WicriEau.data                        \
                                  $(DILIB)/Date/WicriSante.data                      \
                                  $(DILIB)/Date/WicriInformatique.data               \
                                  $(DILIB)/Date/WicriMusique.data                    \
                                  $(DILIB)/Date/WicriTerre.data                      \
                                  $(DILIB)/Date/WicriTicri.data                      \
                                  $(DILIB)/Date/WicriAgronomie.data                  \
                                  $(DILIB)/Date/WicriArcheologie.data               \
                                  $(DILIB)/Date/WicriLinguistique.data               \
                                  $(DILIB)/Date/WicriPsychologie.data                \
                                  $(DILIB)/Date/WicriAsie.data                       \
                                  $(DILIB)/Date/WicriOceanie.data                    \
                                  $(DILIB)/data/Wicri/org.dict                       \
                                  $(DILIB)/data/Wicri/pers.dict                            \
                                  $(DILIB)/data/Wicri/GeoTables/Pays/IsoC3ToPays.tab      \
                                  $(DILIB)/data/Wicri/GeoTables/Pays/IsoC2ToPays.tab     \
                                  $(DILIB)/data/Wicri/GeoTables/Pays/EnglishToPays.tab     \
                                  $(DILIB)/data/Wicri/GeoTables/Pays/LargeCitiesFr.tab       \
                                  $(DILIB)/data/Wicri/GeoTables/France/CodeInseeToRegion.tab  \
                                  $(DILIB)/data/Wicri/GeoTables/Pays/BigCitiesKey.fr.tab  \
                                  $(DILIB)/data/Wicri/GeoTables/France/VillesToTeiPlace.tab  \
                                  $(DILIB)/data/Wicri/GeoTables/USA/StatesToFr.tab            \
                                  $(DILIB)/data/Wicri/GeoTables/USA/CodeStatesToFr.tab            \
                                  $(DILIB)/data/icons/LogoWicriWicriFr.png                    \
                                  $(DILIB)/data/Wicri/BiblioExplorParam.data.tab                \
                                  $(DILIB)/data/Wicri/BiblioExplorParam.en.tab                  \
                                  $(DILIB)/data/Wicri/Rbid2Persee.tab                            \
                                  $(DILIB)/data/Wicri/BigUnivKey.fr.tab                       \
                                  $(DILIB)/data/Wicri/Wicri/wicriUrlLogos.tab                 \
                                  $(DILIB)/data/Wicri/BiblioExplorParam.fr.tab
	$(TOUCH)

$(DILIB)/data/Wicri/org.dict: $(DILIB)/data/Wicri/Europe/orgEurope.dict    \
                              $(DILIB)/data/Wicri/Amerique/org.dict        \
                              $(DILIB)/data/Wicri/Afrique/org.dict         \
                              $(DILIB)/data/Wicri/Asie/orgAsie.dict        \
                              $(DILIB_IMPORT)/Wicri/buildOrgDict.sh
	sh  $(DILIB_IMPORT)/Wicri/buildOrgDict.sh > $@

$(DILIB)/data/Wicri/Wicri/wicriUrlLogos.tab: $(DILIB_IMPORT)/Wicri/Data/Wicri/wicriUrlLogos.wiki \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Wicri/wicriUrlLogos.wiki \
                      |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k1 -v2 > $@

$(DILIB)/data/Wicri/pers.dict: $(DILIB)/data/Wicri/Europe/persEurope.dict    \
                               $(DILIB)/data/Wicri/Amerique/pers.dict    \
                              $(DILIB_IMPORT)/Wicri/buildPersDict.sh
	sh  $(DILIB_IMPORT)/Wicri/buildPersDict.sh > $@

$(DILIB)/Date/WicriEurope.data: $(DILIB)/data/Wicri/Europe/localisationPaysEurope.dict \
                       $(DILIB)/data/Wicri/Europe/paysEurope.dict                      \
                       $(DILIB)/data/Wicri/Espagne/localisationRegionEspagneNuts2.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Europe/paysEurope.dict:$(DILIB_IMPORT)/Wicri/Data/Europe/paysEurope.wiki \
                       $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/Europe/paysEurope.wiki     \
               |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -K1 -V2 > $@ 

$(DILIB)/data/Wicri/Europe/localisationPaysEurope.dict: $(DILIB_IMPORT)/Wicri/Data/Europe/localisationPaysEurope.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Europe/localisationPaysEurope.wiki  >  $@

$(DILIB)/Date/WicriEspagne.data: $(DILIB)/data/Wicri/Espagne/localisationRegionEspagneNuts2.dict  \
                                $(DILIB)/data/Wicri/Espagne/codePostalToNuts2.wiki
	$(TOUCH)

$(DILIB)/data/Wicri/Espagne/localisationRegionEspagneNuts2.dict: $(DILIB_IMPORT)/Wicri/Data/Espagne/localisationRegionEspagneNuts2.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Espagne/localisationRegionEspagneNuts2.wiki  >  $@

$(DILIB)/data/Wicri/Espagne/codePostalToNuts2.wiki:$(DILIB_IMPORT)/Wicri/Data/Espagne/codePostalRegionEspagne.wiki  \
                       $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/Espagne/codePostalRegionEspagne.wiki     \
               |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k1 -V4 > $@ 

$(DILIB)/data/Wicri/Europe/orgEurope.dict: $(DILIB)/data/Wicri/France/orgFrance.dict    \
                                           $(DILIB)/data/Wicri/Europe/orgWicriEurope.dict \
                                           $(DILIB)/data/Wicri/Allemagne/orgAllemagne.dict \
                                           $(DILIB)/data/Wicri/Belgique/orgBelgique.dict \
                               $(DILIB_IMPORT)/Wicri/Data/Europe/buildOrgEuropeDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/Europe/buildOrgEuropeDict.sh > $@

$(DILIB)/data/Wicri/Europe/persEurope.dict: $(DILIB)/data/Wicri/France/persFrance.dict    \
                                            $(DILIB)/data/Wicri/Allemagne/persAllemagne.dict    \
                                            $(DILIB_IMPORT)/Wicri/Data/Europe/persEurope.wiki    \
                               $(DILIB_IMPORT)/Wicri/Data/Europe/buildPersEuropeDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/Europe/buildPersEuropeDict.sh > $@


$(DILIB)/data/Wicri/Europe/orgWicriEurope.dict:$(DILIB_IMPORT)/Wicri/Data/Europe/BigUnivEuropeFr.wiki    \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/SuisseBigUnivFr.wiki    \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/ItalieBigUnivFr.wiki    \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/EspagneBigUnivFr.wiki   \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/listLabosEurope.wiki    \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/organismesEuropeFr.wiki \
                                               $(DILIB_IMPORT)/Wicri/Data/Europe/buildWicriEuropeOrgDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/Europe/buildWicriEuropeOrgDict.sh > $@

$(DILIB)/data/Wicri/interwiki.tab:$(DILIB_ROOT)/Import/Wicri/Data/interwiki.dict  
	cp  $(DILIB_ROOT)/Import/Wicri/Data/interwiki.dict $@

$(DILIB)/Date/WicriAllemagne.data: $(DILIB)/data/Wicri/Allemagne/codePostal4.fr.tab \
                                          $(DILIB)/data/Wicri/Allemagne/codePostal5.fr.tab \
                                          $(DILIB)/data/Wicri/Allemagne/city2place.fr.tab  \
                                          $(DILIB)/data/Wicri/Allemagne/orgAllemagne.dict \
                                          $(DILIB)/data/Wicri/Allemagne/localisationLandsAllemagne.dict \
                                          $(DILIB)/data/Wicri/Allemagne/localisationRegionAllemagneNuts2.dict \
                                          $(DILIB)/data/Wicri/Allemagne/persAllemagne.dict \
                                          $(DILIB)/data/Wicri/Allemagne/scientifiquesAllemagne.dict  \
                                          $(DILIB)/data/Wicri/Allemagne/printIssnAllemagne.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Allemagne/codePostal4.fr.tab: $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostal.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostalBade.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/RhenPal/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Sarre/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildCodePos4.fr.tab.sh \
                                                  $(DILIB)/Date/MediaWiki.bin              \
                                                  $(DILIB)/Date/Tei.bin  
	sh $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildCodePos4.fr.tab.sh > $@

$(DILIB)/data/Wicri/Allemagne/codePostal5.fr.tab: $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostal.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostalBade.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/RhenPal/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Sarre/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildCodePos5.fr.tab.sh \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePos5FromWiki.sh \
                                                  $(DILIB)/Date/MediaWiki.bin              \
                                                  $(DILIB)/Date/Tei.bin  
	sh $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildCodePos5.fr.tab.sh > $@

$(DILIB)/data/Wicri/Allemagne/city2place.fr.tab: $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostal.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/codePostalBade.fr.wiki  \
                                                  $(DILIB_IMPORT)/Wicri/Data/RhenPal/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Sarre/codePostal.fr.wiki      \
                                                  $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildGermanCities.fr.tab.sh \
                                                  $(DILIB)/Date/MediaWiki.bin              \
                                                  $(DILIB)/Date/Tei.bin  
	sh $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildGermanCities.fr.tab.sh > $@

$(DILIB)/data/Wicri/Allemagne/persAllemagne.dict: $(DILIB_IMPORT)/Wicri/Data/Allemagne/PersAllemagne.wiki \
                                           $(DILIB)/Date/MediaWiki.bin              \
                                           $(DILIB)/Date/Tei.bin                    \
                                           $(DILIB)/Date/Wicri.bin                    \
                                           $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildAllemagnePersDict.sh
	sh $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildAllemagnePersDict.sh > $@

$(DILIB)/data/Wicri/Allemagne/scientifiquesAllemagne.dict: $(DILIB_IMPORT)/Wicri/Data/Allemagne/scientifiquesAllemagne.wiki \
                                           $(DILIB)/Date/MediaWiki.bin              \
                                           $(DILIB)/Date/Tei.bin                    \
                                           $(DILIB)/Date/Wicri.bin                   
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-allemmagne.fr < $(DILIB_IMPORT)/Wicri/Data/Allemagne/scientifiquesAllemagne.wiki > $@

$(DILIB)/data/Wicri/Allemagne/orgAllemagne.dict: $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildAllemagneOrgDict.sh \
                       $(DILIB_IMPORT)/Wicri/Data/Allemagne/BigUnivAllemagneFr.wiki   \
                       $(DILIB)/bin/WicriTableOrgFromWiki
	sh $(DILIB_IMPORT)/Wicri/Data/Allemagne/buildAllemagneOrgDict.sh > $@

$(DILIB)/data/Wicri/Allemagne/localisationRegionAllemagneNuts2.dict:$(DILIB_IMPORT)/Wicri/Data/Allemagne/RegionGeoAllemagneNuts2.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki <  $(DILIB_IMPORT)/Wicri/Data/Allemagne/RegionGeoAllemagneNuts2.wiki >  $@


$(DILIB)/data/Wicri/Allemagne/localisationLandsAllemagne.dict: $(DILIB_IMPORT)/Wicri/Data/Allemagne/localisationLandsAllemagne.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Allemagne/localisationLandsAllemagne.wiki >  $@

 $(DILIB)/data/Wicri/Allemagne/printIssnAllemagne.dict: $(DILIB_IMPORT)/Wicri/Data/Allemagne/printIssnAllemagne.wiki \
                             $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Allemagne/printIssnAllemagne.wiki > $@





$(DILIB)/Date/WicriBelgique.data:$(DILIB)/data/Wicri/Belgique/orgBelgique.dict  \
        $(DILIB)/data/Wicri/Belgique/chercheurs.dict  \
        $(DILIB)/data/Wicri/Belgique/codePostal.fr.tab
	$(TOUCH)

$(DILIB)/data/Wicri/Belgique/orgBelgique.dict: $(DILIB_IMPORT)/Wicri/Data/Belgique/buildBelgiqueOrgDict.sh \
                       $(DILIB_IMPORT)/Wicri/Data/Belgique/BigUnivBelgiqueFr.wiki   \
                       $(DILIB_IMPORT)/Wicri/Data/Belgique/BigUnivWallonieFr.wiki   \
                       $(DILIB)/bin/WicriTableOrgFromWiki
	sh $(DILIB_IMPORT)/Wicri/Data/Belgique/buildBelgiqueOrgDict.sh > $@

$(DILIB)/data/Wicri/Belgique/codePostal.fr.tab: $(DILIB_IMPORT)/Wicri/Data/Belgique/codePostal.fr.wiki \
                                                $(DILIB_IMPORT)/Wicri/Data/Belgique/buildCodePostal.tab.sh \
                                                $(DILIB)/Date/MediaWiki.bin              \
                                                $(DILIB)/Date/Tei.bin  
	sh $(DILIB_IMPORT)/Wicri/Data/Belgique/buildCodePostal.tab.sh > $@

$(DILIB)/data/Wicri/Belgique/chercheurs.dict:  $(DILIB_IMPORT)/Wicri/Data/Belgique/chercheursBelgique.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-belgique.fr < $(DILIB_IMPORT)/Wicri/Data/Belgique/chercheursBelgique.wiki > $@


#
#                                                                                                     Wicri/Bresil
#

$(DILIB)/Date/WicriBresil.data:$(DILIB)/data/Wicri/Bresil/code2etat.dict  \
                               $(DILIB)/data/Wicri/Bresil/str2etat.dict   \
                               $(DILIB)/data/Wicri/Bresil/chercheurs.dict   \
                          $(DILIB)/data/Wicri/Bresil/localisationEtatsBresil.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Bresil/code2etat.dict:  $(DILIB_IMPORT)/Wicri/Data/Bresil/etatsBresil.wiki   \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Bresil/etatsBresil.wiki \
             |  MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k3 -V2 > $@

$(DILIB)/data/Wicri/Bresil/str2etat.dict:  $(DILIB_IMPORT)/Wicri/Data/Bresil/etatsBresil.wiki   \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Bresil/etatsBresil.wiki \
             |  MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -K2 -V2 > $@

$(DILIB)/data/Wicri/Bresil/localisationEtatsBresil.dict:  $(DILIB_IMPORT)/Wicri/Data/Bresil/localisationEtatsBresil.wiki \
                                         $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki <$(DILIB_IMPORT)/Wicri/Data/Bresil/localisationEtatsBresil.wiki >$@

$(DILIB)/data/Wicri/Bresil/chercheurs.dict:  $(DILIB_IMPORT)/Wicri/Data/Bresil/chercheursBresil.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-bresil.fr < $(DILIB_IMPORT)/Wicri/Data/Bresil/chercheursBresil.wiki > $@
#
#                                                                                                     Wicri/France
#

$(DILIB)/Date/WicriFrance.data:  $(DILIB)/data/Wicri/France/LaboKey.fr.tab  \
                                        $(DILIB)/data/Wicri/France/orgFrance.dict  \
                                        $(DILIB)/data/Wicri/France/persFrance.dict  \
                                        $(DILIB)/data/Wicri/France/persFranceNationalScope.dict  \
                                        $(DILIB)/data/Wicri/France/VillesToTeiPlace.dict \
                                        $(DILIB)/data/Wicri/France/VillesLcToTeiPlace.dict \
                                        $(DILIB)/data/Wicri/France/villesToTeiPlace.tab   \
                                        $(DILIB)/data/Wicri/France/villesLcToTeiPlace.tab   \
                                        $(DILIB)/data/Wicri/France/localisationRegionFrance.dict  \
                                        $(DILIB)/data/Wicri/France/localisationRegionFrance2016.dict  \
                                        $(DILIB)/data/Wicri/France/codeInseeToRegion.tab         \
                                        $(DILIB)/data/Wicri/France/codeInseeToRegionOld.tab         \
                                        $(DILIB)/data/Wicri/France/Tutelles.fr.tab
	$(TOUCH)

$(DILIB)/data/Wicri/France/orgFrance.dict: $(DILIB_IMPORT)/Wicri/Data/France/Epst.wiki  \
                         $(DILIB_ROOT)/Import/Wicri/Data/France/BigUnivFranceFr.wiki    \
                                         $(DILIB_IMPORT)/Wicri/Data/France/Hopitaux.wiki      \
                                         $(DILIB_IMPORT)/Wicri/Data/France/GrandesEcoles.wiki \
                                          $(DILIB_IMPORT)/Wicri/WicriTableOrgFromWiki    \
                                          $(DILIB_IMPORT)/Wicri/Data/Lorraine/equipesLoriaFr.wiki \
                                           $(DILIB)/data/Wicri/France/LaboKey.fr.tab    \
                                $(DILIB_IMPORT)/Wicri/Data/France/buildFranceOrgDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/France/buildFranceOrgDict.sh > $@

$(DILIB)/data/Wicri/France/villesToTeiPlace.tab: $(DILIB_ROOT)/Import/Wicri/Data/depPrefFrance.wiki \
                     $(DILIB_ROOT)/Import/Wicri/Data/France/BigCitiesFranceFr.wiki  \
                     $(DILIB_ROOT)/Import/Wicri/GeoFranceVille2TeiPlace.sh  \
                     $(DILIB)/Date/Tei.bin                           \
                     $(DILIB)/Date/MediaWiki.bin 
	sh $(DILIB_ROOT)/Import/Wicri/GeoFranceVille2TeiPlace.sh > $@

$(DILIB)/data/Wicri/France/villesLcToTeiPlace.tab: $(DILIB)/data/Wicri/France/villesToTeiPlace.tab  \
                             $(DILIB)/bin/Utf8ToLc                   
	Utf8ToLc -ks < $(DILIB)/data/Wicri/France/villesToTeiPlace.tab  | sort -u > $@

$(DILIB)/data/Wicri/France/VillesLcToTeiPlace.dict: $(DILIB)/data/Wicri/France/VillesToTeiPlace.dict  \
                             $(DILIB)/bin/Utf8ToLc                   
	Utf8ToLc -ks < $(DILIB)/data/Wicri/France/VillesToTeiPlace.dict  | sort -u > $@

$(DILIB)/data/Wicri/France/persFrance.dict:$(DILIB_IMPORT)/Wicri/Data/France/PersRhoneAlpes.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/PersIleDeFrance.wiki  \
                                        $(DILIB_IMPORT)/Wicri/Data/France/PersNord.wiki  \
                                        $(DILIB_IMPORT)/Wicri/Data//Lorraine/pers.wiki      \
                                        $(DILIB)/Date/MediaWiki.bin              \
                                        $(DILIB)/Date/Tei.bin                    \
                                        $(DILIB)/Date/Wicri.bin                    \
                                $(DILIB_IMPORT)/Wicri/Data/France/buildFrancePersDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/France/buildFrancePersDict.sh > $@

$(DILIB)/data/Wicri/France/persFranceNationalScope.dict:$(DILIB_IMPORT)/Wicri/Data/France/persNationalScope.wiki \
                                        $(DILIB)/Date/MediaWiki.bin              \
                                        $(DILIB)/Date/Tei.bin                    \
                                        $(DILIB)/Date/Wicri.bin                    \
                                $(DILIB_IMPORT)/Wicri/Data/France/buildFrancePersNationalDict.sh
	sh  $(DILIB_IMPORT)/Wicri/Data/France/buildFrancePersNationalDict.sh > $@

$(DILIB)/data/Wicri/France/localisationRegionFrance.dict:  $(DILIB_IMPORT)/Wicri/Data/France/RegionGeoFrance.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki <  $(DILIB_IMPORT)/Wicri/Data/France/RegionGeoFrance.wiki > $@

$(DILIB)/data/Wicri/France/localisationRegionFrance2016.dict:  $(DILIB_IMPORT)/Wicri/Data/France/RegionGeoFrance2016.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki <  $(DILIB_IMPORT)/Wicri/Data/France/RegionGeoFrance2016.wiki > $@

$(DILIB)/data/Wicri/France/LaboKey.fr.tab:$(DILIB_IMPORT)/Wicri/Data/Lorraine/LabosFr.wiki  \
                                        $(DILIB_IMPORT)/Wicri/Data/Alsace/LabosFr.wiki  \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosInterUniv.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosRhoneAlpes.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosAquitaine.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosBretagne.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosCentre.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosLanguedoc.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosMidiPyrenees.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosNordPasDeCalais.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosPaca.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosBourgogne.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosFrancheComte.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosIledeFrance.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/LabosOrgFr.wiki \
                                        $(DILIB_IMPORT)/Wicri/Data/France/CnrsUpr.wiki \
                                        $(DILIB)/Date/MediaWiki.bin              \
                                        $(DILIB)/Date/Tei.bin                    \
                                        $(DILIB)/Date/Wicri.bin                    \
                                        $(DILIB_ROOT)/Import/Wicri/buildFranceLaboKey.fr.tab.sh
	sh $(DILIB_ROOT)/Import/Wicri/buildFranceLaboKey.fr.tab.sh >$@

$(DILIB)/data/Wicri/France/Tutelles.fr.tab:$(DILIB_ROOT)/Import/Wicri/buildFranceTutelles.fr.tab.sh \
                                         $(DILIB)/Date/MediaWiki.bin                   \
                                         $(DILIB)/Date/Tei.bin                         \
                                         $(DILIB_IMPORT)/Wicri/Data/France/BigUnivFranceFr.wiki      \
                                         $(DILIB_IMPORT)/Wicri/Data/France/Hopitaux.wiki      \
                                         $(DILIB_IMPORT)/Wicri/Data/France/GrandesEcoles.wiki \
                                         $(DILIB_IMPORT)/Wicri/Data/Amerique/FranceOrgAmeriqueFr.wiki \
                                         $(DILIB)/data/Wicri/org.dict                                  \
                                         $(DILIB_IMPORT)/Wicri/Data/France/CcsdTutelleExceptionsFrance.wiki  \
                                         $(DILIB_IMPORT)/Wicri/Data/Belgique/CcsdTutelleExceptionsBelgique.wiki \
                                         $(DILIB_IMPORT)/Wicri/Data/France/Epst.wiki
	sh $(DILIB_ROOT)/Import/Wicri/buildFranceTutelles.fr.tab.sh > $@

#
#                                                                                                Wicri Lorraine
#

$(DILIB)/Date/WicriLorraine.data: $(DILIB)/data/Wicri/Lorraine/persLoria.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Lorraine/persLoria.dict: $(DILIB_IMPORT)/Wicri/Data/Lorraine/persLoria.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-lorraine.fr < $(DILIB_IMPORT)/Wicri/Data/Lorraine/persLoria.wiki > $@

#
#                                                                                                Wicri Amerique
#

$(DILIB)/Date/WicriAmerique.data:  $(DILIB)/data/Wicri/Amerique/UsaCode2StateFr.tab      \
                                   $(DILIB)/data/Wicri/Amerique/UsaStateToFr.dict      \
                                   $(DILIB)/data/Wicri/Amerique/org.dict  \
                                   $(DILIB)/data/Wicri/Amerique/localisationPaysAmerique.dict \
                                   $(DILIB)/data/Wicri/Amerique/localisations_USA.dict \
                                   $(DILIB)/data/Wicri/Amerique/pers.dict 
	$(TOUCH)

$(DILIB)/data/Wicri/Amerique/org.dict: $(DILIB_IMPORT)/Wicri/Data/Amerique/buildAmeriqueOrgDict.sh \
                                       $(DILIB_IMPORT)/Wicri/Data/Amerique/BigUnivAmeriqueFr.wiki \
                                       $(DILIB_IMPORT)/Wicri/Data/Amerique/labosUsaFr.wiki   \
                                       $(DILIB_IMPORT)/Wicri/Data/Bresil/labosBresilFr.wiki   \
                                       $(DILIB_IMPORT)/Wicri/Data/Amerique/labosCanadaFr.wiki   \
                                       $(DILIB_IMPORT)/Wicri/Data/Bresil/BigUnivBresilFr.wiki \
                                          $(DILIB_IMPORT)/Wicri/WicriTableOrgFromWiki
	sh $(DILIB_IMPORT)/Wicri/Data/Amerique/buildAmeriqueOrgDict.sh > $@

$(DILIB)/data/Wicri/Amerique/pers.dict: $(DILIB_IMPORT)/Wicri/Data/Amerique/buildAmeriquePersDict.sh \
                                       $(DILIB_IMPORT)/Wicri/Data/Amerique/persUsa.wiki \
                                       $(DILIB_IMPORT)/Wicri/Data/Amerique/persCanada.wiki \
                                       $(DILIB_IMPORT)/Wicri/Data/Bresil/persBresil.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                      $(DILIB)/Date/MediaWiki.bin
	sh $(DILIB_IMPORT)/Wicri/Data/Amerique/buildAmeriquePersDict.sh > $@

$(DILIB)/data/Wicri/Amerique/localisationPaysAmerique.dict:$(DILIB_IMPORT)/Wicri/Data/Amerique/localisationPaysAmerique.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Amerique/localisationPaysAmerique.wiki > $@

$(DILIB)/data/Wicri/Amerique/localisations_USA.dict: $(DILIB_IMPORT)/Wicri/Data/Amerique/localisations_USA.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Amerique/localisations_USA.wiki > $@

$(DILIB)/data/Wicri/Amerique/UsaCode2StateFr.tab:  $(DILIB_IMPORT)/Wicri/Data/Amerique/UsaEtatsFr.wiki     \
                                              $(DILIB_IMPORT)/Wicri/Data/Amerique/buildUsaCodeStateDict.sh \
                                              $(DILIB)/Date/MediaWiki.bin                                  \
                                              $(DILIB)/Date/SxPath.bin
	sh $(DILIB_IMPORT)/Wicri/Data/Amerique/buildUsaCodeStateDict.sh < $(DILIB_IMPORT)/Wicri/Data/Amerique/UsaEtatsFr.wiki  > $@

$(DILIB)/data/Wicri/Amerique/UsaStateToFr.dict:$(DILIB_IMPORT)/Wicri/Data/Amerique/UsaEtatsFr.wiki     \
                                              $(DILIB_IMPORT)/Wicri/Data/Amerique/buildUsaStateToFrDict.sh \
                                              $(DILIB)/Date/MediaWiki.bin                                  \
                                              $(DILIB)/Date/SxPath.bin
	sh  $(DILIB_IMPORT)/Wicri/Data/Amerique/buildUsaStateToFrDict.sh <  $(DILIB_IMPORT)/Wicri/Data/Amerique/UsaEtatsFr.wiki  > $@

$(DILIB)/Date/WicriAsie.data: $(DILIB)/data/Wicri/Asie/localisationPaysAsie.dict  \
                              $(DILIB)/data/Wicri/Asie/orgAsie.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Asie/orgAsie.dict:$(DILIB_IMPORT)/Wicri/Data/Asie/BigUnivAsieFr.wiki \
                                      $(DILIB_IMPORT)/Wicri/Data/Asie/listLabosAsie.wiki \
                                      $(DILIB_IMPORT)/Wicri/WicriTableOrgFromWiki
	sh $(DILIB_IMPORT)/Wicri/Data/Asie/buildAsieOrgDict.sh > $@

$(DILIB)/data/Wicri/Asie/localisationPaysAsie.dict: $(DILIB_IMPORT)/Wicri/Data/Asie/localisationPaysAsie.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Asie/localisationPaysAsie.wiki  >  $@


$(DILIB)/Date/WicriAfrique.data: $(DILIB)/data/Wicri/Afrique/localisationPaysAfrique.dict  \
                                 $(DILIB)/data/Wicri/Afrique/org.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Afrique/localisationPaysAfrique.dict: $(DILIB_IMPORT)/Wicri/Data/Afrique/localisationPaysAfrique.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Afrique/localisationPaysAfrique.wiki  >  $@

$(DILIB)/data/Wicri/Afrique/org.dict: $(DILIB_IMPORT)/Wicri/Data/Afrique/buildAfriqueOrgDict.sh \
                                      $(DILIB_IMPORT)/Wicri/Data/Afrique/BigUnivAfriqueFr.wiki  \
                                      $(DILIB_IMPORT)/Wicri/Data/Afrique/orgAfrique.wiki
	sh $(DILIB_IMPORT)/Wicri/Data/Afrique/buildAfriqueOrgDict.sh > $@

$(DILIB)/Date/WicriOceanie.data: $(DILIB)/data/Wicri/Oceanie/localisationPaysOceanie.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Oceanie/localisationPaysOceanie.dict: $(DILIB_IMPORT)/Wicri/Data/Oceanie/localisationPaysOceanie.wiki \
                                          $(DILIB)/bin/WicriTableRegionFromWiki
	WicriTableRegionFromWiki < $(DILIB_IMPORT)/Wicri/Data/Oceanie/localisationPaysOceanie.wiki  >  $@

#
#                        Agronomie
#

$(DILIB)/Date/WicriAgronomie.data: $(DILIB)/data/Wicri/Agronomie/printIssnAgronomie.dict \
                                   $(DILIB)/data/Wicri/Agronomie/persAgronomie.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Agronomie/printIssnAgronomie.dict: $(DILIB_IMPORT)/Wicri/Data/Agronomie/printIssnAgronomie.wiki \
                             $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Agronomie/printIssnAgronomie.wiki > $@

$(DILIB)/data/Wicri/Agronomie/persAgronomie.dict: $(DILIB_IMPORT)/Wicri/Data/Agronomie/persAgronomie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-agronomie.fr <  $(DILIB_IMPORT)/Wicri/Data/Agronomie/persAgronomie.wiki > $@

#
#                        Linguistique
#
$(DILIB)/Date/WicriLinguistique.data:$(DILIB)/data/Wicri/Linguistique/persLinguistique.dict \
                    $(DILIB)/data/Wicri/Linguistique/printIssnLinguistique.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Linguistique/persLinguistique.dict:$(DILIB_IMPORT)/Wicri/Data/Linguistique/persLinguistique.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-linguistique.fr < $(DILIB_IMPORT)/Wicri/Data/Linguistique/persLinguistique.wiki > $@

$(DILIB)/data/Wicri/Linguistique/printIssnLinguistique.dict: $(DILIB_IMPORT)/Wicri/Data/Linguistique/printIssnLinguistique.wiki \
                             $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Linguistique/printIssnLinguistique.wiki > $@


#
#                        Archeologie
#
$(DILIB)/Date/WicriArcheologie.data:$(DILIB)/data/Wicri/Archeologie/persArcheologie.dict \
                    $(DILIB)/data/Wicri/Archeologie/printIssnArcheologie.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Archeologie/persArcheologie.dict:$(DILIB_IMPORT)/Wicri/Data/Archeologie/persArcheologie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-archeologie.fr < $(DILIB_IMPORT)/Wicri/Data/Archeologie/persArcheologie.wiki > $@

$(DILIB)/data/Wicri/Archeologie/printIssnArcheologie.dict: $(DILIB_IMPORT)/Wicri/Data/Archeologie/printIssnArcheologie.wiki \
                             $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Archeologie/printIssnArcheologie.wiki > $@

#
#                        Psychologie
#
$(DILIB)/Date/WicriPsychologie.data:$(DILIB)/data/Wicri/Psychologie/persPsychologie.dict \
                                    $(DILIB)/data/Wicri/Psychologie/printIssnPsycho.dict
	$(TOUCH)


$(DILIB)/data/Wicri/Psychologie/persPsychologie.dict:$(DILIB_IMPORT)/Wicri/Data/Psychologie/specialistesPsycho.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/Data/Psychologie/buildPsychoPersDict.sh \
                                         $(DILIB)/Date/MediaWiki.bin
	sh $(DILIB_IMPORT)/Wicri/Data/Psychologie/buildPsychoPersDict.sh > $@

$(DILIB)/data/Wicri/Psychologie/printIssnPsycho.dict:$(DILIB_IMPORT)/Wicri/Data/Psychologie/printIssnPsycho.wiki \
                             $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Psychologie/printIssnPsycho.wiki > $@

$(DILIB)/Date/WicriTicri.data: $(DILIB)/data/Wicri/Ticri/persTicriH2ptm.dict \
                               $(DILIB)/data/Wicri/Ticri/printIssnBibliotheconomie.dict  \
                               $(DILIB)/data/Wicri/Ticri/persTicriCide.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Ticri/persTicriH2ptm.dict:$(DILIB_IMPORT)/Wicri/Data/Ticri/persTicriH2ptm.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r ticri-h2ptm.fr < $(DILIB_IMPORT)/Wicri/Data/Ticri/persTicriH2ptm.wiki > $@

$(DILIB)/data/Wicri/Ticri/persTicriCide.dict:$(DILIB_IMPORT)/Wicri/Data/Ticri/persTicriCide.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r ticri-cide.fr < $(DILIB_IMPORT)/Wicri/Data/Ticri/persTicriCide.wiki > $@


$(DILIB)/Date/WicriEau.data:$(DILIB)/data/Wicri/Eau/persEau.dict  \
                            $(DILIB)/data/Wicri/Eau/persEauPoissons.dict \
                            $(DILIB)/data/Wicri/Eau/persBiochimie.dict \
                            $(DILIB)/data/Wicri/Eau/printIssnIchtyologie.dict  \
                            $(DILIB)/data/Wicri/Eau/printIssnHydrologie.dict 
	$(TOUCH)

$(DILIB)/data/Wicri/Eau/persEau.dict:$(DILIB_IMPORT)/Wicri/Data/Eau/persEau.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-eau.fr < $(DILIB_IMPORT)/Wicri/Data/Eau/persEau.wiki > $@

$(DILIB)/data/Wicri/Eau/persEauPoissons.dict:$(DILIB_IMPORT)/Wicri/Data/Eau/persEauPoissons.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-eau.fr < $(DILIB_IMPORT)/Wicri/Data/Eau/persEauPoissons.wiki > $@

$(DILIB)/data/Wicri/Eau/persBiochimie.dict:$(DILIB_IMPORT)/Wicri/Data/Eau/persBiochimie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-eau.fr < $(DILIB_IMPORT)/Wicri/Data/Eau/persBiochimie.wiki > $@


$(DILIB)/data/Wicri/Eau/printIssnIchtyologie.dict:$(DILIB_IMPORT)/Wicri/Data/Eau/printIssnIchtyologie.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Eau/printIssnIchtyologie.wiki > $@

$(DILIB)/data/Wicri/Eau/printIssnHydrologie.dict:$(DILIB_IMPORT)/Wicri/Data/Eau/printIssnHydrologie.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Eau/printIssnHydrologie.wiki > $@


#$(DILIB)/Date/WicriBois.data: $(DILIB)/data/Wicri/Bois/printIssnSylviculture.dict \
                              $(DILIB)/data/Wicri/Bois/printIssnZoologie.dict     \
                              $(DILIB)/data/Wicri/Bois/persZoologie.dict          \
                              $(DILIB)/data/Wicri/Bois/persSylviculture.dict
#	$(TOUCH)

#$(DILIB)/data/Wicri/Bois/printIssnSylviculture.dict:$(DILIB_IMPORT)/Wicri/Data/Bois/printIssnSylviculture.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
#	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Bois/printIssnSylviculture.wiki > $@

#$(DILIB)/data/Wicri/Bois/printIssnZoologie.dict:$(DILIB_IMPORT)/Wicri/Data/Bois/printIssnZoologie.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Bois/printIssnZoologie.wiki > $@

#$(DILIB)/data/Wicri/Bois/persSylviculture.dict: $(DILIB_IMPORT)/Wicri/Data/Bois/persSylviculture.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
#	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-bois.fr < $(DILIB_IMPORT)/Wicri/Data/Bois/persSylviculture.wiki > $@

#$(DILIB)/data/Wicri/Bois/persZoologie.dict: $(DILIB_IMPORT)/Wicri/Data/Bois/persZoologie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
#	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-bois.fr < $(DILIB_IMPORT)/Wicri/Data/Bois/persZoologie.wiki > $@

$(DILIB)/Date/WicriMusique.data:$(DILIB)/data/Wicri/Musique/persMusicologie.dict \
                                $(DILIB)/data/Wicri/Musique/printIssnMusicologie.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Musique/persMusicologie.dict: $(DILIB_IMPORT)/Wicri/Data/Musique/persMusicologie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-musique.fr < $(DILIB_IMPORT)/Wicri/Data/Musique/persMusicologie.wiki > $@

$(DILIB)/data/Wicri/Musique/printIssnMusicologie.dict:$(DILIB_IMPORT)/Wicri/Data/Musique/printIssnMusicologie.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Musique/printIssnMusicologie.wiki > $@

$(DILIB)/Date/WicriSante.data:$(DILIB)/data/Wicri/Sante/persSante.dict  \
                        $(DILIB)/data/Wicri/Sante/printIssnSante.dict  \
                        $(DILIB)/data/Wicri/Sante/persNeurologie.dict 
	$(TOUCH)

$(DILIB)/data/Wicri/Sante/persSante.dict:$(DILIB_IMPORT)/Wicri/Data/Sante/persSante.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-sante.fr < $(DILIB_IMPORT)/Wicri/Data/Sante/persSante.wiki > $@

$(DILIB)/data/Wicri/Sante/persNeurologie.dict:$(DILIB_IMPORT)/Wicri/Data/Sante/persNeurologie.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-sante.fr < $(DILIB_IMPORT)/Wicri/Data/Sante/persNeurologie.wiki > $@

$(DILIB)/data/Wicri/Sante/printIssnSante.dict:$(DILIB_IMPORT)/Wicri/Data/Sante/printIssnSante.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Sante/printIssnSante.wiki  > $@

$(DILIB)/data/Wicri/Ticri/printIssnBibliotheconomie.dict: $(DILIB_IMPORT)/Wicri/Data/Ticri/printIssnBibliotheconomie.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Ticri/printIssnBibliotheconomie.wiki  > $@

$(DILIB)/Date/WicriTerre.data:$(DILIB)/data/Wicri/Terre/persMateriaux.dict  \
                              $(DILIB)/data/Wicri/Terre/persGenieChimique.dict \
                              $(DILIB)/data/Wicri/Terre/chimieMeshToWicri.dict \
                              $(DILIB)/data/Wicri/Terre/chimieWicriFrToElementCode.dict \
                              $(DILIB)/data/Wicri/Terre/chimieElementCodeToSerie.dict \
                              $(DILIB)/data/Wicri/Terre/chimieSerieToStyle.dict \
                              $(DILIB)/data/Wicri/Terre/printIssnGenieChimique.dict \
                              $(DILIB)/data/Wicri/Terre/printIssnMateriaux.dict 
	$(TOUCH)

$(DILIB)/data/Wicri/Terre/persMateriaux.dict: $(DILIB_IMPORT)/Wicri/Data/Terre/persMateriaux.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-terre.fr < $(DILIB_IMPORT)/Wicri/Data/Terre/persMateriaux.wiki > $@

$(DILIB)/data/Wicri/Terre/persGenieChimique.dict: $(DILIB_IMPORT)/Wicri/Data/Terre/persGenieChimique.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-terre.fr < $(DILIB_IMPORT)/Wicri/Data/Terre/persGenieChimique.wiki > $@

$(DILIB)/data/Wicri/Terre/printIssnGenieChimique.dict:$(DILIB_IMPORT)/Wicri/Data/Terre/printIssnGenieChimique.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Terre/printIssnGenieChimique.wiki  > $@

$(DILIB)/data/Wicri/Terre/printIssnMateriaux.dict:$(DILIB_IMPORT)/Wicri/Data/Terre/printIssnMateriaux.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Terre/printIssnMateriaux.wiki  > $@

$(DILIB)/data/Wicri/Terre/chimieMeshToWicri.dict:$(DILIB_IMPORT)/Wicri/Data/Terre/chimieMeshToWicri.wiki \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Terre/chimieMeshToWicri.wiki \
                      |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k1 -V2 | sort  > $@

$(DILIB)/data/Wicri/Terre/chimieWicriFrToElementCode.dict:$(DILIB_IMPORT)/Wicri/Data/Terre/chimieWicriFrToElementCode.wiki \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Terre/chimieWicriFrToElementCode.wiki \
                      |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -K2 -v3 > $@

$(DILIB)/data/Wicri/Terre/chimieElementCodeToSerie.dict: $(DILIB_IMPORT)/Wicri/Data/Terre/chimieWicriFrToElementCode.wiki \
                                   $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_IMPORT)/Wicri/Data/Terre/chimieWicriFrToElementCode.wiki \
                      |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k3 -V4 > $@

$(DILIB)/data/Wicri/Terre/chimieSerieToStyle.dict: $(DILIB_IMPORT)/Wicri/Data/Terre/chimieStyleComposant.wiki \
                                   $(DILIB)/bin/MediaWikiTableTransformCol  \
                                   $(DILIB)/bin/SxmlSelect
	MediaWikiCleanTable <  $(DILIB_IMPORT)/Wicri/Data/Terre/chimieStyleComposant.wiki \
             |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -K 1 -n2 -N color -E2 -c 345 \
            | SxmlSelect -g r/color -p @1 -p @g1 | sort > $@


$(DILIB)/Date/WicriInformatique.data:$(DILIB)/data/Wicri/Informatique/persGenieLog.dict \
                                     $(DILIB)/data/Wicri/Informatique/printIssnInformatique.dict
	$(TOUCH)

$(DILIB)/data/Wicri/Informatique/persGenieLog.dict: $(DILIB_IMPORT)/Wicri/Data/Informatique/persGenieLog.wiki \
                                          $(DILIB)/bin/TeiTablePersFromWiki  \
                                          $(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTablePersFromWiki.sh -r wicri-informatique.fr < $(DILIB_IMPORT)/Wicri/Data/Informatique/persGenieLog.wiki > $@

$(DILIB)/data/Wicri/Informatique/printIssnInformatique.dict:$(DILIB_IMPORT)/Wicri/Data/Informatique/printIssnInformatique.wiki \
                                          $(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh  \
                                         $(DILIB)/Date/MediaWiki.bin
	$(DILIB_IMPORT)/Wicri/buildTableEditInclude.sh < $(DILIB_IMPORT)/Wicri/Data/Informatique/printIssnInformatique.wiki > $@

$(DILIB)/Date/WicriMetadata.data:  $(DILIB)/data/Wicri/Metadata/IsoC3ToPays.tab      \
                                          $(DILIB)/data/Wicri/Metadata/IsoC3ToCountry.tab   \
                                          $(DILIB)/data/Wicri/Metadata/IsoOldC3ToPays.tab   \
                                          $(DILIB)/data/Wicri/Metadata/IsoC2ToPays.tab      \
                                          $(DILIB)/data/Wicri/Metadata/CountryToPays.tab    \
                                          $(DILIB)/data/Wicri/Metadata/CountryLcToPays.tab  \
                                          $(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab    \
                                          $(DILIB)/data/Wicri/Metadata/BigUnivLcToPays.tab  \
                                          $(DILIB)/data/Wicri/Metadata/IndexGeoEn2Fr.tab    \
                                          $(DILIB)/data/Wicri/Metadata/IndexTopicEn2Fr.tab  \
                                          $(DILIB)/data/Wicri/Metadata/IndexTopicFr2Fr.tab  \
                                          $(DILIB)/data/Wicri/Metadata/CitiesToPays.tab    \
                                          $(DILIB)/data/Wicri/Metadata/RegionsToPays.tab   \
                                          $(DILIB)/data/Wicri/Metadata/PaysToPays.tab      \
                                          $(DILIB)/data/Wicri/Metadata/PaysToIsoC2.tab     \
                                          $(DILIB)/data/Wicri/Metadata/postalCodeGlobal.fr.tab     \
                                          $(DILIB)/data/Wicri/Metadata/RegionsCities.fr.tab
	$(TOUCH)

$(DILIB)/data/Wicri/Metadata/IsoC3ToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Metadata/Iso3166.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki |SgmlSelect -g r/c2/i# -p @g1 -g r/c4/l# -p @g2 | sort > $@

$(DILIB)/data/Wicri/Metadata/IsoC3ToCountry.tab: $(DILIB_ROOT)/Import/Wicri/Data/Metadata/Iso3166En.wiki  \
                                     $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable <  $(DILIB_ROOT)/Import/Wicri/Data/Metadata/Iso3166En.wiki \
                |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k3 -V1 > $@ 

$(DILIB)/data/Wicri/Metadata/IsoOldC3ToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Metadata/Iso3166Comp.wiki  \
                       $(DILIB)/bin/MediaWikiTableTransformCol
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/Metadata/Iso3166Comp.wiki     \
               |MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -k2 -V5 > $@ 

$(DILIB)/data/Wicri/Metadata/IsoC2ToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki |SgmlSelect -g r/c3/i# -p @g1 -g r/c4/l# -p @g2 | sort > $@

$(DILIB)/data/Wicri/Metadata/CountryToPays.tab: $(DILIB)/data/Wicri/Metadata/IsoC3ToPays.tab \
                             $(DILIB)/data/Wicri/Metadata/IsoC3ToCountry.tab \
                             $(DILIB_IMPORT)/Wicri/buildCountryToPays.sh                     \
                             $(DILIB_IMPORT)/Wicri//Data/Metadata/EnglishToPays.wiki
	sh $(DILIB_IMPORT)/Wicri/buildCountryToPays.sh > $@

$(DILIB)/data/Wicri/Metadata/PaysToPays.tab: $(DILIB)/data/Wicri/Metadata/IsoC3ToPays.tab \
                             $(DILIB_IMPORT)/Wicri/Data/Metadata/buildPaysToPays.sh                     \
                             $(DILIB)/bin/SgmlSelect
	sh $(DILIB_IMPORT)/Wicri/Data/Metadata/buildPaysToPays.sh > $@

$(DILIB)/data/Wicri/Metadata/PaysToIsoC2.tab: $(DILIB)/data/Wicri/Metadata/IsoC2ToPays.tab \
                             $(DILIB)/bin/SgmlSelect
	SgmlSelect -p @2 -p @1 < $(DILIB)/data/Wicri/Metadata/IsoC2ToPays.tab     > $@

$(DILIB)/data/Wicri/Metadata/CountryLcToPays.tab: $(DILIB)/data/Wicri/Metadata/CountryToPays.tab \
                             $(DILIB)/bin/Utf8ToLc                   
	Utf8ToLc -ks < $(DILIB)/data/Wicri/Metadata/CountryToPays.tab | sort -u > $@

$(DILIB)/data/Wicri/Metadata/BigUnivLcToPays.tab: $(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab \
                             $(DILIB)/bin/Utf8ToLc                   
	Utf8ToLc -ks < $(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab | sort -u > $@

$(DILIB)/data/Wicri/Metadata/CitiesToPays.tab: $(DILIB_ROOT)/Import/Wicri/buildBigCitiesKey.fr.tab.sh  \
                            $(DILIB)/Date/MediaWiki.bin              \
                            $(DILIB)/Date/Tei.bin                    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Amerique/BigCitiesAmeriqueFr.wiki \
                            $(DILIB_ROOT)/Import/Wicri/Data/Asie/BigCitiesAsieFr.wiki \
                            $(DILIB_ROOT)/Import/Wicri/Data/Afrique/BigCitiesAfriqueFr.wiki \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/BigCitiesEuropeFr.wiki 
	sh $(DILIB_ROOT)/Import/Wicri/buildBigCitiesKey.fr.tab.sh >$@

$(DILIB)/data/Wicri/Metadata/RegionsToPays.tab: $(DILIB_ROOT)/Import/Wicri/buildRegionsFr.tab.sh  \
                            $(DILIB)/Date/MediaWiki.bin              \
                            $(DILIB)/Date/Tei.bin                    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/RegionForCountryEuropeFr.wiki \
                            $(DILIB_ROOT)/Import/Wicri/Data/Amerique/UsaEtatsFr.wiki       \
                            $(DILIB_ROOT)/Import/Wicri/Data/Asie/regionsAsieFr.wiki       \
                            $(DILIB_ROOT)/Import/Wicri/Data/Amerique/regionsAmeriqueFr.wiki
	sh $(DILIB_ROOT)/Import/Wicri/buildRegionsFr.tab.sh >$@

$(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab:  $(DILIB_ROOT)/Import/Wicri/buildBigUnivToPays.sh  \
                            $(DILIB)/Date/MediaWiki.bin              \
                            $(DILIB)/Date/Tei.bin                    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Asie/BigUnivAsieFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/France/BigUnivFranceFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Allemagne/BigUnivAllemagneFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Belgique/BigUnivBelgiqueFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Belgique/BigUnivWallonieFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/BigUnivEuropeFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/SuisseBigUnivFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/ItalieBigUnivFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/EspagneBigUnivFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Amerique/BigUnivAmeriqueFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Afrique/BigUnivAfriqueFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Bresil/BigUnivBresilFr.wiki
	sh $(DILIB_ROOT)/Import/Wicri/buildBigUnivToPays.sh > $@

$(DILIB)/data/Wicri/Metadata/IndexGeoEn2Fr.tab:$(DILIB)/data/Wicri/Metadata/CountryToPays.tab \
                                           $(DILIB_IMPORT)/Eurovoc/Data/EurovocGeoEn.wiki    \
                                           $(DILIB_IMPORT)/Wicri/buildMetaIndexGeoEn2Fr.sh
	sh $(DILIB_IMPORT)/Wicri/buildMetaIndexGeoEn2Fr.sh > $@

$(DILIB)/data/Wicri/Metadata/IndexTopicEn2Fr.tab:$(DILIB)/data/Wicri/Metadata/IndexGeoEn2Fr.tab    \
                                                 $(DILIB)/data/Eurovoc/En2Fr.tab                   \
                                                 $(DILIB_IMPORT)/Wicri/buildMetaIndexTopicEn2Fr.sh \
                                                 $(DILIB_IMPORT)/Wicri/Data/Ticri/IndexTopic.wiki  \
                                                 $(DILIB)/Date/StrDict.bin  
	sh $(DILIB_IMPORT)/Wicri/buildMetaIndexTopicEn2Fr.sh > $@

$(DILIB)/data/Wicri/Metadata/IndexTopicFr2Fr.tab:$(DILIB)/data/Wicri/Metadata/IndexGeoEn2Fr.tab        \
                                            $(DILIB_IMPORT)/Wicri/Data/Metadata/buildIndexTopicFr2Fr.sh \
                                            $(DILIB)/data/Eurovoc/En2Fr.tab                            \
                                            $(DILIB)/bin/SxmlSelect
	sh $(DILIB_IMPORT)/Wicri/Data/Metadata/buildIndexTopicFr2Fr.sh > $@

$(DILIB)/data/Wicri/Metadata/RegionsCities.fr.tab:  $(DILIB_IMPORT)/Wicri/buildRegionsCitiesKey.fr.tab.sh \
                                                    $(DILIB_IMPORT)/Wicri/Data/Europe/BigCitiesEuropeFr.wiki     \
                                                    $(DILIB_IMPORT)/Wicri/Data/Amerique/BigCitiesAmeriqueFr.wiki   \
                                                    $(DILIB_IMPORT)/Wicri/Data/Asie/BigCitiesAsieFr.wiki       \
                                                    $(DILIB_IMPORT)/Wicri/Data/AmeriqueUsaCitiesFr.wiki   \
                                                    $(DILIB_IMPORT)/Wicri/Data/EuropeIrlandeCitiesFr.wiki \
                                                    $(DILIB_IMPORT)/Wicri/Data/UsaEtatsFr.wiki            \
                                                    $(DILIB)/Date/MediaWiki.bin                    \
                                                    $(DILIB)/Date/Tei.bin 
	sh $(DILIB_IMPORT)/Wicri/buildRegionsCitiesKey.fr.tab.sh  > $@

$(DILIB)/data/Wicri/Metadata/postalCodeGlobal.fr.tab: $(DILIB_IMPORT)/Wicri/Data/Metadata/buildCodePostalGlobal.fr.sh \
                                $(DILIB_IMPORT)/Wicri/Data/Belgique/buildCodePostal.tab.sh             \
                                $(DILIB_IMPORT)/Wicri/Data/Europe/AutricheCodePostal.fr.wiki         \
                                                $(DILIB)/Date/MediaWiki.bin                  \
                                                $(DILIB)/Date/Tei.bin
	sh $(DILIB_IMPORT)/Wicri/Data/Metadata/buildCodePostalGlobal.fr.sh > $@

$(DILIB)/data/Wicri/BigUnivKey.fr.tab: $(DILIB_ROOT)/Import/Wicri/buildBigUnivKey.fr.tab.sh  \
                            $(DILIB)/bin/WicriTableOrgFromWiki                               \
                            $(DILIB)/Date/MediaWiki.bin              \
                            $(DILIB_ROOT)/Import/Wicri/Data/Asie/BigUnivAsieFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/France/BigUnivFranceFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Allemagne/BigUnivAllemagneFr.wiki    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Afrique/BigUnivAfriqueFr.wiki      \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/BigUnivEuropeFr.wiki 
	sh $(DILIB_ROOT)/Import/Wicri/buildBigUnivKey.fr.tab.sh > $@

$(DILIB)/data/Wicri/GeoTables/Pays/BigCitiesKey.fr.tab: $(DILIB_ROOT)/Import/Wicri/buildBigCitiesKey.fr.tab.sh  \
                            $(DILIB)/Date/MediaWiki.bin              \
                            $(DILIB)/Date/Tei.bin                    \
                            $(DILIB_ROOT)/Import/Wicri/Data/Europe/BigCitiesEuropeFr.wiki 
	sh $(DILIB_ROOT)/Import/Wicri/buildBigCitiesKey.fr.tab.sh >$@

$(DILIB)/data/Wicri/GeoTables/Pays/IsoC3ToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki |SgmlSelect -g r/c2/i# -p @g1 -g r/c4/l# -p @g2 | sort > $@

$(DILIB)/data/Wicri/GeoTables/Pays/IsoC2ToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/Iso3166.wiki |SgmlSelect -g r/c3/i# -p @g1 -g r/c4/l# -p @g2 | sort > $@

#                      To be deprecated
$(DILIB)/data/Wicri/GeoTables/France/VillesToTeiPlace.tab: $(DILIB_ROOT)/Import/Wicri/Data/depPrefFrance.wiki \
                     $(DILIB_ROOT)/Import/Wicri/Data/France/BigCitiesFranceFr.wiki  \
                     $(DILIB_ROOT)/Import/Wicri/GeoFranceVille2TeiPlace.sh  \
                     $(DILIB)/Date/Tei.bin                           \
                     $(DILIB)/Date/MediaWiki.bin 
	sh $(DILIB_ROOT)/Import/Wicri/GeoFranceVille2TeiPlace.sh > $@

$(DILIB)/data/Wicri/France/VillesToTeiPlace.dict: $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki \
                     $(DILIB_ROOT)/Import/Wicri/Data/France/BigCitiesFranceFr.wiki  \
                     $(DILIB_ROOT)/Import/Wicri/Data/France/buildFranceVille2TeiPlace.sh  \
                     $(DILIB)/Date/Tei.bin                           \
                     $(DILIB)/Date/MediaWiki.bin 
	sh $(DILIB_ROOT)/Import/Wicri/Data/France/buildFranceVille2TeiPlace.sh > $@

$(DILIB)/data/Wicri/GeoTables/Pays/EnglishToPays.tab: $(DILIB_ROOT)/Import/Wicri/Data/Metadata/EnglishToPays.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/Metadata/EnglishToPays.wiki | SgmlSelect -g r/c3/i# -p @g1 -g r/c1/l# -p @g2 | sort > $@

$(DILIB)/data/Wicri/GeoTables/Pays/LargeCitiesFr.tab: $(DILIB_ROOT)/Import/Wicri/Data/LargeCitiesFr.wiki  \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/LargeCitiesFr.wiki | SgmlSelect -g r/c1/i# -p @g1 -g r/c2 -p @g2  | sort > $@

$(DILIB)/data/Wicri/GeoTables/France/CodeInseeToRegion.tab: $(DILIB_ROOT)/Import/Wicri/Data/depPrefFrance.wiki \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml < $(DILIB_ROOT)/Import/Wicri/Data/depPrefFrance.wiki  |SgmlSelect -g r/c1/i# -p @g1 -g r/c4/l# -p @g2 | sort  > $@

$(DILIB)/data/Wicri/France/codeInseeToRegion.tab: $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki \
                       $(DILIB)/Date/MediaWiki.bin
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki  |MediaWikiTable2SxmlRowCol |MediaWikiTableTransformCol -k 1 -V 4 | sort  > $@

$(DILIB)/data/Wicri/France/codeInseeToRegionOld.tab: $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki \
                       $(DILIB)/Date/MediaWiki.bin
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki  |MediaWikiTable2SxmlRowCol |MediaWikiTableTransformCol -k 1 -V 5 | sort  > $@

$(DILIB)/data/Wicri/France/codeInseeToOldRegion.tab: $(DILIB_ROOT)/Import/Wicri/Data/France/depRegFrance.wiki \
                       $(DILIB)/date/MediaWiki.bin
	MediaWikiCleanTable < $(DILIB_ROOT)/Import/Wicri/Data/depPrefFrance.wiki  |MediaWikiTable2SxmlRowCol |MediaWikiTableTransformCol -k 1 -V 5 | sort  > $@

$(DILIB)/data/Wicri/GeoTables/USA/StatesToFr.tab: $(DILIB_ROOT)/Import/Wicri/Data/Amerique/UsaEtatsFr.wiki \
                       $(DILIB)/bin/MediaWikiTable2Sxml  \
                        $(DILIB)/bin/SgmlSelect
	MediaWikiTable2Sxml <  $(DILIB_ROOT)/Import/Wicri/Data/Amerique/UsaEtatsFr.wiki | SxmlSelect -g r/c1/l/1 -g r/c2/i/1 -p @g2 -p @g1  | sort  > $@

$(DILIB)/data/Wicri/GeoTables/USA/CodeStatesToFr.tab: $(DILIB_ROOT)/Import/Wicri/Data/Amerique/UsaEtatsFr.wiki \
                        $(DILIB)/bin/MediaWikiTableTransformCol  \
                        $(DILIB)/bin/MediaWikiTable2SxmlRowCol      \
                        $(DILIB)/bin/MediaWikiCleanTable         \
                        $(DILIB)/bin/SxmlSelect
	MediaWikiCleanTable  <  $(DILIB_ROOT)/Import/Wicri/Data/Amerique/UsaEtatsFr.wiki | MediaWikiTable2SxmlRowCol | MediaWikiTableTransformCol -l1 | SxmlSelect -g r/c3/l/1 -p @g1 -g r/c1/p/k/1 -p @g2 | sort > $@

$(DILIB)/data/icons/LogoWicriWicriFr.png: $(DILIB_ROOT)/Import/Wicri/Data/LogoWicriWicriFr.png
	cp $(DILIB_ROOT)/Import/Wicri/Data/LogoWicriWicriFr.png $@

$(DILIB)/data/Wicri/BiblioExplorParam.data.tab: $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.data.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.data.wiki > $@

$(DILIB)/data/Wicri/BiblioExplorParam.en.tab: $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.en.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.en.wiki > $@

$(DILIB)/data/Wicri/BiblioExplorParam.fr.tab: $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.fr.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Wicri/Data/WicriBiblioExplorParam.fr.wiki > $@

$(DILIB)/data/Wicri/Rbid2Persee.tab : $(DILIB_IMPORT)/Wicri/Data/PerseeLienArcheo.wiki \
                  $(DILIB)/Date/SxmlNode.bin \
                  $(DILIB)/Date/MediaWiki.bin
	cat $(DILIB_IMPORT)/Wicri/Data/PerseeLienArcheo.wiki    \
             | MediaWikiCleanTable|MediaWikiTable2SxmlRowCol    \
             | SgmlSelect -g r/c1/l# -g r/c2/l# -p @g1 -p @g2  > $@ 

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Wicri.php: $(DILIB)/php/Wicri/Wicri.php
	$(TOUCH)

$(DILIB)/php/Wicri/Wicri.php: $(DILIB_IMPORT)/Wicri/Wicri.php
	cp $(DILIB_IMPORT)/Wicri/Wicri.php $@

#--------------------------------- end Wicri.mk ----------------------------------------
