/*   -*- coding: utf-8 -*-  */

/*
           WicriBiblio22CorpusTei.c

 */

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>

#include "TeiHandler.h"
#include "Buffer.h"

SxmlNode *docInput;
SxmlNode *corpusRecord;
SxmlNode *teiRoot;

int main()
{
  char *dateDoc;
  dateDoc=malloc(5);
  while ((docInput=SxmlInputNextDocumentElement()))
    {
      SxmlNode *docu;
      SxmlNode *titleNode;
      SxmlNode *premierAuteurNode;
      SxmlNode *idno;
      SxmlNode *pageNode;
      char *pageName;
 

      corpusRecord=SxmlElementCreate("record");
      SxmlAppendChild(corpusRecord, teiRoot=TeiHandlerNew());

      docu=SxmlClone(docInput);
      SxmlSetNodeName(docu,strdup("wicri")); /* strdup pour SxmlFree() */
      SxmlAppendChild(corpusRecord,docu);

      SxmlAppendChild(Tei_publicationStmt, idno=SxmlLeafCreate("idno", SxmlRecordKeyString(SxmlStdinRecord)));
      SxmlSetAttribute(idno, "type", "explorId");

      if ((pageNode=SxmlGetFirstChildTagAtt(docInput, "c", "property", "Page")))
	{
	  char *posParenthesis;
	  pageName=SxmlLeafText(pageNode);
	  posParenthesis=strchr(pageName,'(');
	  strncpy(dateDoc,posParenthesis+1,4);
	  TeiSetDatePublication(dateDoc);
	}

      if ((titleNode=SxmlGetFirstChildTagAtt(docInput, "c", "property", "A pour titre")))
	{
	  SxmlAppendChild(Tei_titleStmt,SxmlLeafCreate("title", SxmlLeafText(titleNode)));
	}

      if ((premierAuteurNode=SxmlGetFirstChildTagAtt(docInput, "c", "property", "A pour premier auteur")))
	{
	  SxmlNode *teiAuthorNode;
	  SxmlAppendChild (Tei_titleStmt, teiAuthorNode=SxmlElementCreate ("author"));
	  SxmlAppendChild (teiAuthorNode, SxmlLeafCreate("name", SxmlLeafText(premierAuteurNode)));
	}
      
      SxmlPrint(corpusRecord);
      putchar('\n');
      SxmlFree(corpusRecord);
    }
  exit (EXIT_SUCCESS);
}
